package edu.washington.cs.rfid.mstreams.data;

import java.text.DecimalFormat;


public class StateTransition implements Comparable<StateTransition> {

   private static final String TOKEN_DELIMETER = ";";
   
   //--//
   
   public int    state1;
   public int    state2;
   public double prob;
   
   //--//
      
   public StateTransition(int state1, int state2, double prob){
      this.state1 = state1;
      this.state2 = state2;
      this.prob   = prob;
   }
   
   
   public boolean equals(StateTransition n){
      return this.state1 == n.state1 && this.state2 == n.state2 && this.prob == n.prob;
   }
   
   
   public int compareTo(StateTransition t){
      int result = 0;
      
      if(this.state1 > t.state1){
         result = 1;
      } else if(this.state1 < t.state1){
         result = -1;
      } else {
         if(this.state2 > t.state2){
            result = 1;
         } else if(this.state2 < t.state2){
            result = -1;
         } else {
            if(this.prob > t.prob){
               result = 1;
            } else if(this.prob < t.prob){
               result = -1;
            } else {
               result = 0;
            }
         }
      }
      
      return result;
   }
   
   public String toPrettyString(){
      DecimalFormat df = new DecimalFormat("#.####");
      return "(" + state1 + StateTransition.TOKEN_DELIMETER + 
                   state2 + StateTransition.TOKEN_DELIMETER + 
                   df.format(this.prob) + ")";
   }
   
   public String toString(){
      return "(" + state1 + StateTransition.TOKEN_DELIMETER + state2 + StateTransition.TOKEN_DELIMETER + this.prob + ")";
   }
}
