package edu.washington.cs.rfid.mstreams.event;

import java.io.IOException;
import java.sql.SQLException;

import api.queryResults.QueryResult;
import edu.washington.cs.rfid.mstreams.data.StreamKey;
import edu.washington.cs.rfid.mstreams.data.db.BdbConnection;
import edu.washington.cs.rfid.mstreams.data.db.LaharConnection;
import edu.washington.cs.rfid.mstreams.data.db.StreamKeyManager;

public class AtEvent extends ScenicEvent {

   protected String desc;
   
   //--//
   
   /**
    * Creates a new AtEvent.
    * @param desc
    */
   public AtEvent(final String desc){
      super();
      this.desc = desc;
   }
   
   
   /**
    * Gets the description of this event stream
    * @return
    */
   public String getStreamDescription(){
      return new String(this.desc);
   }
   
   
   /**
    * Executes the event using the given Lahar instance and returns a query result.
    * @param lahar
    * @return
    */
   public QueryResult executeQuery(final BdbConnection    bdb  ,
                                   final LaharConnection  lahar, 
                                   final StreamKeyManager keyManager) throws IOException,
                                                                             ClassNotFoundException,
                                                                             SQLException {
      QueryResult result = null;
      StreamKey   sk     = this.getStreamKey(keyManager);
      
      if(lahar.streamKeyExists(sk, this.particleFilterSchema)){
         result = lahar.loadCachedResult(sk, this.particleFilterSchema);
      }
      return result;
   }
}
