package edu.washington.cs.rfid.map.client.data;

import com.google.gwt.user.client.rpc.IsSerializable;

public class Particle implements IsSerializable {

   public String color;
   public double prob;
   public String floor;
   public LatLon loc;
   
   //--//
   
   /**
    * Creates a new particle.
    */
   public Particle(){
      this.color  = null;
      this.floor  = null;
      this.loc    = null;
      this.prob   = -1.0;
   }
   
   
   /**
    * Create a new particle.
    * @param floor
    * @param loc
    * @param prob
    */
   public Particle(String floor, LatLon loc, double prob){
      this.floor = floor;
      this.loc   = loc;
      this.prob  = prob;
   }
   
   
   /**
    * Create a new particle.
    * @param color
    * @param floor
    * @param loc
    * @param prob
    */
   public Particle(String color, String floor, LatLon loc, double prob){
      this.color = color;
      this.floor = floor;
      this.loc   = loc;
      this.prob  = prob;
   }
   
   
   public boolean equals(Particle p){
      return this.color.equals(p.color) &&
             this.floor.equals(p.floor) &&
             this.loc.lat == p.loc.lat  &&
             this.loc.lon == p.loc.lon  &&
             this.prob    == p.prob;
   }
}
