package edu.washington.cs.rfid.cascadia.panoramic.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException;
import com.google.gwt.user.client.rpc.InvocationException;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.RootPanel;

import edu.washington.cs.rfid.cascadia.scenic.client.ui.ScenicToolbar;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;

/**
 * The Entry Point for the Panoramic tool.
 */
public class PanoramicTool implements EntryPoint {

   /**
    * Create a remote service proxy to talk to the server-side Greeting service.
    */
   private final GreetingServiceAsync clientProxy = GWT.create(GreetingService.class);
   
   //--//
   
   // The event specification toolbar.
   private ScenicToolbar toolbar;
   
   //--//
   
   /**
    * This is the entry point method.
    */
   public void onModuleLoad() {
      GWT.setUncaughtExceptionHandler(new GWT.UncaughtExceptionHandler() {
         public void onUncaughtException(Throwable throwable) {
            
            String text = "Uncaught exception: ";
            
            while (throwable != null) {
               StackTraceElement[] stackTraceElements = throwable.getStackTrace();
               text                                  += throwable.toString() + "\n";
               
               for (int i = 0; i < stackTraceElements.length; i++) {
                  text += "    at " + stackTraceElements[i] + "\n";
               }
               throwable = throwable.getCause();
               if (throwable != null) {
                  text += "Caused by: ";
               }
            }
            DialogBox dialogBox = new DialogBox(true);
//            DOM.setStyleAttribute(dialogBox.getElement(), "backgroundColor", "#ABCDEF");
            System.err.print(text);
            text = text.replaceAll(" ", "&nbsp;");
            dialogBox.setHTML("<pre>" + text + "</pre>");
            dialogBox.center();
         }
      });

      // use a deferred command so that the handler catches onModuleLoad2() exceptions
      DeferredCommand.addCommand(new Command() {
         public void execute() {
            onModuleLoad2();
         }
      });
   }
   
   
   private int taskNum = -1;
   
   private void onModuleLoad2() {
      this.toolbar = ScenicToolbar.getInstance();
      RootPanel.get().add( this.toolbar );
  
      
      HorizontalPanel hp = new HorizontalPanel();
      hp.setWidth("100%");
      hp.setHorizontalAlignment(HorizontalPanel.ALIGN_CENTER);
      Button nextTaskButton = new Button("Submit Event");
      nextTaskButton.addClickHandler(new ClickHandler(){
         public void onClick(ClickEvent e){
//            taskNum++;
//            if(null != display){
//               display.curTracePackNum = taskNum;
//            }
//            clientProxy.getResultBundle(taskNum,getBundleCallback);
         }
      });
      hp.add(nextTaskButton);
      hp.setCellHorizontalAlignment(nextTaskButton, HorizontalPanel.ALIGN_CENTER);
      RootPanel.get().add(hp);
   }
   
   
   //--//
   
   
   private final AsyncCallback<ScenicEventResultBundle> getBundleCallback = 
                  new AsyncCallback<ScenicEventResultBundle>() {
      
      public void onSuccess(ScenicEventResultBundle result) {
//         if(null != result){
//            toolbar.loadTemplateFromXml(result.templateXml);
//            
//            if(null != display){
//               RootPanel.get().remove(display);
//            }
//            display = ScenicTimelineDisplay.getInstance(result);
//            display.curTracePackNum = taskNum;
//            
//            RootPanel.get().add(display);
//         }
      }

      public void onFailure(Throwable caught) {
         // Convenient way to find out which exception was thrown.
         try {
            throw caught;
         } catch (IncompatibleRemoteServiceException e) {
            // this client is not compatible with the server; cleanup and refresh the browser
         } catch (InvocationException e) {
            // the call didn't complete cleanly
         } catch (Throwable e) {
            // last resort -- a very unexpected exception
         }
      }
   };
}
