package edu.washington.cs.rfid.cascadia.panoramic.client.data;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.rpc.IsSerializable;

import edu.washington.cs.rfid.map.client.data.LatLon;

public class CompactMStreamElement implements IsSerializable {

   public long         timeSec;
   public List<LatLon> particles;
   public int          floor;
   
   public CompactMStreamElement(){
      this.timeSec = -1;
      this.particles = null;
      this.floor  = 3;
   }
   
   public CompactMStreamElement(long timeSec){
      this.timeSec   = timeSec;
      this.particles = new ArrayList<LatLon>();
      this.floor  = 3;
   }
   
   public CompactMStreamElement(long timeSec, List<LatLon> particles){
      this.timeSec = timeSec;
      this.particles = particles;
      this.floor  = 3;
   }
   
   public CompactMStreamElement(CompactMStreamElement m){
      this.timeSec = m.timeSec;
      this.particles = new ArrayList<LatLon>();
      
      for(LatLon p : m.particles){
         this.particles.add(new LatLon(p.lat,p.lon));
      }
      this.floor  = m.floor;
   }
   
   public void addParticle(double lat, double lon){
      this.particles.add(new LatLon(lat,lon));
   }
   
   public String toString(){
      String str = this.timeSec + "";
      for(LatLon latlon : this.particles){
         str += "," + latlon.lat + "," + latlon.lon;
      }
      return str;
   }
}
