package edu.washington.cs.rfid.cascadia.panoramic.client.data;

import com.google.gwt.user.client.rpc.IsSerializable;

import edu.washington.cs.rfid.map.client.data.LatLon;

public class CompactTre implements IsSerializable {

   public long    timeSec;
   public LatLon  latlon;
   public boolean blank;
   public int     floor;
   
   //--//
   
   public CompactTre(){
      this.timeSec = -1;
      this.latlon  = null;
      this.blank   = true;
      this.floor   = 3;
   }
   
   public CompactTre(long timeSec){
      this.timeSec = timeSec;
      this.latlon  = null;
      this.blank   = true;
      this.floor   = 3;
   }
   
   public CompactTre(long timeSec, double lat, double lon){
      this.timeSec = timeSec;
      this.latlon  = new LatLon(lat,lon);
      this.blank   = false;
      this.floor   = 3;
   }
   
   public CompactTre(CompactTre tre){
      this.timeSec = tre.timeSec;
      this.blank   = tre.blank;
      if(!this.blank){
         this.latlon  = new LatLon(tre.latlon.lat,tre.latlon.lon);
      }
      this.floor   = tre.floor;
   }
   
   public String toString(){
      String str = (this.blank)? timeSec + "" :
                                 timeSec + "," + latlon.lat + "," + latlon.lon;
      return str;
   }
}
