package edu.washington.cs.rfid.cascadia.panoramic.client.data;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.google.gwt.user.client.rpc.IsSerializable;

public class TracePack implements IsSerializable {

   public String               key;
   public Date                 startDate;
   public Map<String,TraceSet> keyToTraceSetMap;
   
   public TracePack(){
      this.key              = null;
      this.startDate        = null;
      this.keyToTraceSetMap = new HashMap<String,TraceSet>();
   }
   
   public TracePack(String key){
      this.key              = key;
      this.startDate        = null;
      this.keyToTraceSetMap = new HashMap<String,TraceSet>();
   }
   
   public void addTraceSet(TraceSet set){
      this.keyToTraceSetMap.put(set.key, set);
   }
   
   public long getStartTime(){
      long minStartTime = -1;
      for(String key : this.keyToTraceSetMap.keySet()){
         TraceSet set = this.keyToTraceSetMap.get(key);
         minStartTime = set.getStartTime();
         break;
      }
      return minStartTime;
   }
   
   public long getEndTime(){
      long maxEndTime = -1;
      for(String key : this.keyToTraceSetMap.keySet()){
         TraceSet set = this.keyToTraceSetMap.get(key);
         maxEndTime   = set.getEndTime();
         break;
      }
      return maxEndTime;
   }
}
