package edu.washington.cs.rfid.cascadia.panoramic.client.data;

import com.google.gwt.user.client.rpc.IsSerializable;


/**
 * Stores a data and a model trace that should be perfectly in sync
 * @author evan
 */
public class TraceSet implements IsSerializable {

   public String           key;
   public String           name;
   public String           dataIconUrl;
   public String           modelIconUrl;
   public CompactTreStream dataStream;
   public CompactMStream   modelStream;
   
   public TraceSet(){
      this.key          = null;
      this.name         = null;
      this.dataIconUrl  = null;
      this.modelIconUrl = null;
      this.dataStream   = null;
      this.modelStream  = null;
   }
   
   public TraceSet(String key, String name, String dataIconUrl, String modelIconUrl, CompactTreStream dataStream, CompactMStream modelStream){
      this.key          = key;
      this.name         = name;
      this.dataIconUrl  = dataIconUrl;
      this.modelIconUrl = modelIconUrl;
      this.dataStream   = dataStream;
      this.modelStream  = modelStream;
   }
   
   
   public TraceSet(TraceSet set){
      this.key = set.key;
      this.name = set.name;
      this.dataIconUrl = set.dataIconUrl;
      this.modelIconUrl = set.modelIconUrl;
      this.dataStream = new CompactTreStream(set.dataStream);
      this.modelStream = new CompactMStream(set.modelStream);
   }
   
   
   public long getStartTime(){
      long startTime = -1;
    
      if(null != this.dataStream        && 
         null != this.dataStream.stream && 
         this.dataStream.stream.size() > 0){
         startTime = this.dataStream.stream.get(0).timeSec;
      }
      return startTime;
   }
   
   public long getEndTime(){
      long endTime = -1;
      
      if(null != this.dataStream        && 
            null != this.dataStream.stream && 
            this.dataStream.stream.size() > 0){
            endTime = this.dataStream.stream.get(this.dataStream.stream.size()-1).timeSec;
      }
      return endTime;
   }
}
