package edu.washington.cs.rfid.cascadia.playback.client.data;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * Holds the options for playback of a given location stream.
 * 
 * @author evan
 */
public class PlaybackOptions implements IsSerializable {
   
   public String traceName;
   public String followedKey;
   
   public String trackedEntityName;
   public String trackedEntityType;
   public String trackedEntityImgUrl;
   
   public String particleColor;
   public String particleImgUrl;

   //--//
   
   /**
    * Creates a default PlaybackOptions.
    */
   public PlaybackOptions(){
      this.traceName           = null;
      this.followedKey         = null;
      this.trackedEntityName   = null;
      this.trackedEntityType   = null;
      this.trackedEntityImgUrl = null;
      this.particleColor       = null;
      this.particleImgUrl      = null;
   }

   
   /**
    * Creates a new PlaybackOptions object.
    * @param traceName
    * @param followedKey
    * @param trackedEntityName
    * @param trackedEntityType
    * @param trackedEntityUrl
    * @param particleColor
    * @param particleUrl
    */
   public PlaybackOptions(String traceName          ,
                          String followedKey        ,
                          String trackedEntityName  ,
                          String trackedEntityType  ,
                          String trackedEntityImgUrl,
                          String particleColor      ,
                          String particleImgUrl){
      this.traceName           = traceName;
      this.followedKey         = followedKey;
      this.trackedEntityName   = trackedEntityName;
      this.trackedEntityType   = trackedEntityType;
      this.trackedEntityImgUrl = trackedEntityImgUrl;
      this.particleColor       = particleColor;
      this.particleImgUrl      = particleImgUrl;
   }
}