package edu.washington.cs.rfid.cascadia.scenic.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.RootPanel;

import edu.washington.cs.rfid.cascadia.scenic.client.grammar.ScenicSequence;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.ScenicToolbar;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class ScenicWidget implements EntryPoint {


   /**
    * Create a remote service proxy to talk to the server-side Greeting service.
    */
   private final GreetingServiceAsync greetingService = GWT.create(GreetingService.class);

   //--//
   
   private ScenicToolbar toolbar;
   
   //--//
   
   public void onModuleLoad() {
      GWT.setUncaughtExceptionHandler(new GWT.UncaughtExceptionHandler() {
         public void onUncaughtException(Throwable throwable) {
            
            String text = "Uncaught exception: ";
            
            while (throwable != null) {
               StackTraceElement[] stackTraceElements = throwable.getStackTrace();
               text                                  += throwable.toString() + "\n";
               
               for (int i = 0; i < stackTraceElements.length; i++) {
                  text += "    at " + stackTraceElements[i] + "\n";
               }
               throwable = throwable.getCause();
               if (throwable != null) {
                  text += "Caused by: ";
               }
            }
            DialogBox dialogBox = new DialogBox(true);
            DOM.setStyleAttribute(dialogBox.getElement(), "backgroundColor", "#ABCDEF");
            System.err.print(text);
            text = text.replaceAll(" ", "&nbsp;");
            dialogBox.setHTML("<pre>" + text + "</pre>");
            dialogBox.center();
         }
      });

      // use a deferred command so that the handler catches onModuleLoad2() exceptions
      DeferredCommand.addCommand(new Command() {
         public void execute() {
            onModuleLoad2();
         }
      });
   }

   private void onModuleLoad2() {
      this.toolbar = ScenicToolbar.getInstance();
      RootPanel.get().add( this.toolbar );
      
      Button specButton = new Button("Get XML");
      specButton.addClickHandler(new ClickHandler(){
         public void onClick(ClickEvent e){
            ScenicSequence spec = toolbar.getSpecification();
            
            toolbar.clearSequence();
            
            toolbar.loadTemplateFromXml(spec.toXml());
            
            //Window.alert(spec.toXml());
            
         }
      });
      
      RootPanel.get().add(specButton);
      
      
   }
}
