package edu.washington.cs.rfid.cascadia.scenic.client.command;

import java.util.Vector;

import com.google.gwt.user.client.Command;

import edu.washington.cs.rfid.cascadia.scenic.client.ui.Scene;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.ActorWidget;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.ConnectorHandleWidget;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.PrimitiveWidget;

/**
 * A Command to redraw all the connectors in a scene once
 * all the scene components have been attached to the DOM.
 * @author evan
 */
public class ConnectorRedrawCmd implements Command {
   
   private Scene s;
   
   public ConnectorRedrawCmd(Scene s){
      this.s = s;
   }
   
   public void execute(){
      Vector<ConnectorHandleWidget> connectors = this.s.getConnectorHandleWidgets();
      
      for(ConnectorHandleWidget connector : connectors){
         ActorWidget     aw = connector.actorWidget;
         PrimitiveWidget pw = connector.primitiveWidget;
         
         if(null != aw && null != pw){
            connector.actorX     = this.s.getWidgetLeft(aw) + aw.getRelativeXConnectorAnchor();
            connector.actorY     = this.s.getWidgetTop (aw) + aw.getRelativeYConnectorAnchor();
            connector.primitiveX = this.s.getWidgetLeft(pw) + pw.getRelativeXConnectorAnchor();
            connector.primitiveY = this.s.getWidgetTop (pw) + pw.getRelativeYConnectorAnchor();
         }
      }
      this.s.redrawConnectors();
   }
}

