package edu.washington.cs.rfid.cascadia.scenic.client.exception;

import edu.washington.cs.rfid.cascadia.scenic.client.grammar.ScenicPrimitive;

public class TranslationNotSupportedException extends Exception{
	
   private ScenicPrimitive prim;
	private boolean         primIsSpecified;  
	
	//--//
	
	public TranslationNotSupportedException(ScenicPrimitive prim){
		this.prim 			   = prim;
		this.primIsSpecified = true; 
	}
	
	public TranslationNotSupportedException(){
		this.primIsSpecified = false; 
	}
	
	public String toString(){
		if(primIsSpecified == true){
			return "Sorry but the translation not supported here due to the " + 
					 prim.getClass().getName() + " primitive.";  
		} else {
			return "Sorry translation not supported here."; 
		}
	}
}
