package edu.washington.cs.rfid.cascadia.scenic.client.ui;

import com.google.gwt.user.client.ui.FocusPanel;
import com.google.gwt.user.client.ui.ScrollPanel;

/**
 * A panel that holds the sequence panel and its containing focus panel.
 * @author evan
 */
public class SequenceViewer extends ScrollPanel  {

   protected static final String SEQUENCE_VIEWER_STYLE = "sequenceViewer";
   protected static final String WIDTH                 = "100%";
   protected static final String HEIGHT                = "400px";
   
   //--//
   
   protected FocusPanel    sequenceFocusPanel;
   protected SequencePanel sequencePanel;

   //--//

   /**
    * Creates a new <code>SequencePanel</code>.
    * 
    * @param sequencePanel
    */
   public SequenceViewer(SequencePanel sequencePanel){
      
      this.setStyleName( SequenceViewer.SEQUENCE_VIEWER_STYLE        );
      this.setSize     ( SequenceViewer.WIDTH, SequenceViewer.HEIGHT );
      
      this.sequenceFocusPanel = new FocusPanel();
      this.sequencePanel      = sequencePanel;
   
      this.sequenceFocusPanel.add(this.sequencePanel);
      this.sequenceFocusPanel.addMouseUpHandler(this.sequencePanel);
      
      this.add(this.sequenceFocusPanel);
      this.sequenceFocusPanel.setVisible(true);
   }
}
