package edu.washington.cs.rfid.cascadia.timeline.client.ui;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

import edu.washington.cs.rfid.cascadia.scenic.client.ui.SequencePanel;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class ScenicEventBubbleInfo extends VerticalPanel {

   public ScenicTimelineEvent event;
   public HTML                title;
   public SequencePanel       thumbail;
   public HTML                description;
   public HTML                start;
   public HTML                end;
   public Button              replayButton;
   
   //--//
   
   /**
    * 
    * @param event
    */
   public ScenicEventBubbleInfo(SequencePanel thumbnail){
      this.event    = null;
      this.title    = new HTML("Title");
      this.thumbail = thumbnail;
      
      AbsolutePanel line = new AbsolutePanel();
      line.setPixelSize(300, 2);
      line.setStyleName("timeline-bar");
      
      this.description = new HTML("Description");
      this.start       = new HTML("Start:");
      this.end         = new HTML("End:");
      
      HorizontalPanel thumbBump = new HorizontalPanel();
      HTML bump = new HTML("&nbsp;");
      thumbBump.add(bump);
      thumbBump.setCellWidth(bump,"10px");
      thumbBump.add(this.thumbail);
      
      this.add(this.title);
      this.add(line);
      HTML spacer1 = new HTML("");
      spacer1.setHeight("10px");
      this.add(spacer1);
      this.setCellHeight(spacer1, "10px");
      this.add(thumbBump);
      HTML spacer2 = new HTML("");
      spacer2.setHeight("10px");
      this.add(spacer2);
      this.setCellHeight(spacer2, "10px");
      this.add(this.description);
      HTML spacer3 = new HTML("");
      spacer3.setHeight("10px");
      this.add(spacer3);
      this.setCellHeight(spacer3, "10px");
      this.add(this.start);
      this.add(this.end);
      HTML spacer4 = new HTML("");
      spacer4.setHeight("10px");
      this.add(spacer4);
      this.setCellHeight(spacer4, "10px");
      
      HorizontalPanel replayPanel = this.buildReplayPanel();
      this.add(replayPanel);
      
      HTML spacer5 = new HTML("");
      spacer5.setHeight("10px");
      this.add(spacer5);
      this.setCellHeight(spacer5, "10px");
      
      this.setCellHorizontalAlignment(this.description, HorizontalPanel.ALIGN_CENTER);
      this.setCellHorizontalAlignment(this.start, HorizontalPanel.ALIGN_CENTER);
      this.setCellHorizontalAlignment(this.end, HorizontalPanel.ALIGN_CENTER);
      this.setCellHorizontalAlignment(replayPanel, HorizontalPanel.ALIGN_CENTER);
   }
   
   
   public void setEvent(ScenicTimelineEvent event){
      this.event = event;
      this.title.setHTML(event.title);
      this.description.setHTML(event.description);
      this.start.setHTML(event.start);
      if(null != event.end){
         this.end.setHTML(event.end);
      } else {
         this.end.setHTML("");
      }
   }
   
   
   public HorizontalPanel buildReplayPanel(){
      HorizontalPanel hp = new HorizontalPanel();
      
      this.replayButton = new Button("Cue Playback");
      this.replayButton.addClickHandler(new ClickHandler(){
         public void onClick(ClickEvent e){
            ScenicTimelinePanel panel = ScenicTimelinePanel.getInstance();
            panel.cuePlayback(event.start);
         }
      });
      
      hp.add(this.replayButton);
      hp.setHorizontalAlignment(HorizontalPanel.ALIGN_CENTER);
      hp.setCellHorizontalAlignment(this.replayButton, HorizontalPanel.ALIGN_CENTER);
      
      return hp;
   }
}
