package edu.washington.cs.rfid.cascadia.scenic.client.grammar;

import java.util.ArrayList;

import edu.washington.cs.rfid.cascadia.scenic.client.xml.Node;


public class ScenicThing extends ScenicActor {
   
   public ScenicThing(){
      super();
   }
   
   public ScenicThing(ArrayList<Node> kids){
       super(kids);
   }
   
   public ScenicThing(int id, String name, boolean type, int left, int top, String imgUrl) {
      super(id, name, type, left, top, imgUrl);
   }

   public String toXml(){
       return this.toXml(0);
   }
 
   /**
    * Generates an XML representation of this object.
    * @return
    */
   @Override
   public String toXml(int level){
       
       String indent = "";
       
       for(int i = 0; i < level; i++){
          indent += "\t";
       }
       
       String xml = indent + "<scenicthing>\n" + 
                    indent + "\t<id>"     + this.id     + "</id>\n"     +
                    indent + "\t<name>"   + this.name   + "</name>\n"   +
                    indent + "\t<type>"   + this.type   + "</type>\n"  +
                    indent + "\t<left>"   + this.left   + "</left>\n"   + 
                    indent + "\t<top>"    + this.top    + "</top>\n"    +
                    indent + "\t<imgurl>" + this.imgUrl + "</imgurl>\n" +
                    indent + "</scenicthing>\n";
       return xml;
   }
}
