package edu.washington.cs.rfid.cascadia.scenic.client.grammar;

import java.util.ArrayList;

import edu.washington.cs.rfid.cascadia.scenic.client.xml.Node;

public class ScenicThingGrp extends ScenicActor {

   protected static final String SIZE = "size";
   
   //--//
    
   public static final int DEFAULT_GROUP_SIZE = 4;
   
   //--//
   
   public int size;
   
   //--//
   
   public ScenicThingGrp(){
      super();
      
      this.size = ScenicThingGrp.DEFAULT_GROUP_SIZE;
   }
   
   public ScenicThingGrp(ArrayList<Node> kids){
      super(kids);
       
      for(int i = 0; i < kids.size(); i++){
         Node kid = kids.get(i);
      
         if(kid.getName().equals(ScenicThingGrp.SIZE)){
            try {
               this.size = Integer.parseInt(kid.getValue());
            } catch(NumberFormatException e){
               this.size = 1;
            }
         }
      }
   }
   
   public ScenicThingGrp(int id, String name, int left, int top, String imgUrl) {
      super(id, name, left, top, imgUrl);

      this.size = ScenicThingGrp.DEFAULT_GROUP_SIZE;
   }
   
   public String toXml(){
       return this.toXml(0);
   }
   
   /**
    * Generates an XML representation of this object.
    * @return
    */
   @Override
   public String toXml(int level){
       
       String indent = "";
       
       for(int i = 0; i < level; i++){
          indent += "\t";
       }
       
       String xml = indent + "<scenicthinggrp>" + 
                    indent + "\t<id>"     + this.id     + "</id>\n"     +
                    indent + "\t<name>"   + this.name   + "</name>\n"   +
                    indent + "\t<left>"   + this.left   + "</left>\n"   + 
                    indent + "\t<top>"    + this.top    + "</top>\n"    +
                    indent + "\t<imgurl>" + this.imgUrl + "</imgurl>\n" +
                    indent + "\t<size>"   + this.size   + "</size>\n"   +
                    indent + "</scenicthinggrp>\n";
       return xml;
   }
}