package edu.washington.cs.rfid.cascadia.scenic.client.grammar;

import java.util.ArrayList;

import com.google.gwt.user.client.rpc.IsSerializable;

import edu.washington.cs.rfid.cascadia.scenic.client.xml.Node;

public class ScenicTransition implements IsSerializable {

   protected static final String TYPE_TRANSITION = "type";
   protected static final String TYPE_NEXT       = "next";
   protected static final String TYPE_BEFORE     = "before";
   
   //--//
   
   protected String type;
   
   //--//
   
   public ScenicTransition(){
      this.type = null;
   }
   
   
   public ScenicTransition(String type){
      this.type = type;
   }
   
   
   public ScenicTransition(ArrayList<Node> kids){
      for(int i = 0; i < kids.size(); i++){
         Node kid = kids.get(i);
     
         if(kid.getName().equals(ScenicTransition.TYPE_TRANSITION)){
            this.type = ((Node)kid.getChildNodes().get(0)).getValue();
         }
      }
   }
   
   
   public String getType(){
      return this.type;
   }
   
   
   public void setType(String type){
      this.type = type;
   }
   
   
   public String toXml(){
      return this.toXml(0);
  }
  
  /**
   * Generates an XML representation of this object.
   * @return
   */
  public String toXml(int level){
      
      String indent = "";
      
      for(int i = 0; i < level; i++){
         indent += "\t";
      }
      
      String xml = indent + "<scenictransition>\n" + 
                   indent + "\t<type>" + this.type + "</type>\n" +
                   indent + "</scenictransition>\n";
      return xml;
  }
}
