package edu.washington.cs.rfid.cascadia.scenic.client.ui;

public class LineSegment {

   public static final double DASH_LEN                        = 5.0;
   public static final double DASH_LEN_THUMBNAIL              = 2.0;
   
   public static final double WIDTH_CONNECTING                = 3.0;
   public static final double WIDTH_CONNECTED                 = 4.0;
   public static final double WIDTH_CONNECTED_THUMBNAIL       = 2.0;
   public static final double WIDTH_TARGET                    = 3.0;
   public static final double WIDTH_DIVIDING_LINE             = 1.0;
   public static final double WIDTH_TRANSITION_LINE           = 4.0;
   public static final double WIDTH_TRANSITION_LINE_THUMBNAIL = 1.0;
   
   public static final String COLOR_CONNECTING          = "#f7a071";
   public static final String COLOR_CONNECTED           = "#f8874a";
   public static final String COLOR_TARGET              = "#f6d0bb";
   public static final String COLOR_DIVIDING_LINE       = "#DDDDDD";
   
   //--//
   
   public int     x1, y1, x2, y2;
   public double  width;
   public String  color;
   public boolean dotted;
   
   //--//
   
   public LineSegment(){
      this.x1     = 0;
      this.y1     = 0;
      this.x2     = 0;
      this.y2     = 0;
      this.width  = LineSegment.WIDTH_CONNECTING;
      this.color  = LineSegment.COLOR_CONNECTING;
      this.dotted = false;
   }
   
   public LineSegment(int x1, int y1, int x2, int y2, double width, String color, boolean dotted){
      this.x1     = x1;
      this.y1     = y1;
      this.x2     = x2;
      this.y2     = y2;
      this.width  = width;
      this.color  = color;
      this.dotted = dotted;
   }
   
   public double getLength(){
      return Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
   }
}
