package edu.washington.cs.rfid.cascadia.scenic.client.ui;

import com.allen_sauer.gwt.dnd.client.DragContext;
import com.allen_sauer.gwt.dnd.client.drop.AbsolutePositionDropController;
import com.google.gwt.user.client.ui.AbsolutePanel;

import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.ActorWidget;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.IconWidget;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.widget.PrimitiveWidget;

public class SceneDropController extends AbsolutePositionDropController {
   
   protected Scene         s;
   protected AbsolutePanel ap;
   
   //--//
   
   public SceneDropController(Scene s, AbsolutePanel ap){
      super(ap);
      
      this.s  = s;
      this.ap = ap;
   }
   
   
   public void onDrop(DragContext context){
      
      ScenicToolbar toolbar = ScenicToolbar.getInstance();
      IconWidget i = (IconWidget)context.draggable;
      
      toolbar.sequencePanel.signalWidgetAddition(i, this.s);
      
      i.setScene(this.s);
      
      if(i instanceof ActorWidget){
         
         this.s.addActorWidget((ActorWidget)i);
         
      } else if(i instanceof PrimitiveWidget){
         
         this.s.addPrimitiveWidget((PrimitiveWidget)i);
      }
   }
}
