package edu.washington.cs.rfid.cascadia.scenic.client.ui.factory;

import java.util.Vector;

import com.google.gwt.user.client.ui.Image;

import edu.washington.cs.rfid.cascadia.scenic.client.data.Person;
import edu.washington.cs.rfid.cascadia.scenic.client.data.PersonGrp;
import edu.washington.cs.rfid.cascadia.scenic.client.data.Place;
import edu.washington.cs.rfid.cascadia.scenic.client.data.Thing;
import edu.washington.cs.rfid.cascadia.scenic.client.data.ThingGrp;

/**
 * Downloads and maintains a personal library of actors for a user.
 * 
 * @author Evan
 */
public class ActorLibrary {
	
	protected Vector<Image>     imageCache;

	protected Vector<Person>    people;
	protected Vector<PersonGrp> personGrps;
	protected Vector<Thing>     things;
	protected Vector<ThingGrp>  thingGrps;
	protected Vector<Place>     places;

	public ActorLibrary(){
		
		this.imageCache = new Vector<Image>();
		
		this.imageCache.add( new Image( "images/person-orange.png" ) );
		this.imageCache.add( new Image( "images/person-blue.png" ) );
		this.imageCache.add( new Image( "images/person-blue-green.png" ) );
		this.imageCache.add( new Image( "images/person-pink.png" ) );
		this.imageCache.add( new Image( "images/person-purple.png" ) );
		this.imageCache.add( new Image( "images/person-red.png" ) );
		this.imageCache.add( new Image( "images/person-yellow.png" ) );
		
		this.imageCache.add( new Image( "images/group-person-orange.png" ) );
		this.imageCache.add( new Image( "images/group-person-blue.png" ) );
		this.imageCache.add( new Image( "images/group-person-blue-green.png" ) );
		this.imageCache.add( new Image( "images/group-person-pink.png" ) );
		this.imageCache.add( new Image( "images/group-person-purple.png" ) );
		this.imageCache.add( new Image( "images/group-person-red.png" ) );
		this.imageCache.add( new Image( "images/group-person-yellow.png" ) );
		
		this.imageCache.add( new Image( "images/group-person-orange.png" ) );
		this.imageCache.add( new Image( "images/group-person-blue.png" ) );
		this.imageCache.add( new Image( "images/group-person-blue-green.png" ) );
		this.imageCache.add( new Image( "images/group-person-pink.png" ) );
		this.imageCache.add( new Image( "images/group-person-purple.png" ) );
		this.imageCache.add( new Image( "images/group-person-red.png" ) );
		this.imageCache.add( new Image( "images/group-person-yellow.png" ) );
		
		this.imageCache.add( new Image( "images/group-object-orange.png" ) );
		this.imageCache.add( new Image( "images/group-object-blue.png" ) );
		this.imageCache.add( new Image( "images/group-object-blue-green.png" ) );
		this.imageCache.add( new Image( "images/group-object-pink.png" ) );
		this.imageCache.add( new Image( "images/group-object-purple.png" ) );
		this.imageCache.add( new Image( "images/group-object-red.png" ) );
		this.imageCache.add( new Image( "images/group-object-yellow.png" ) );

		this.imageCache.add( new Image( "images/mug.png" ) );
		this.imageCache.add( new Image( "images/book.png" ) );
		this.imageCache.add( new Image( "images/backpack.png" ) );
		this.imageCache.add( new Image( "images/ipod.png" ) );
		this.imageCache.add( new Image( "images/keys.png" ) );
		this.imageCache.add( new Image( "images/laptop.png" ) );
		this.imageCache.add( new Image( "images/notebook.png" ) );
		this.imageCache.add( new Image( "images/umbrella.png" ) );
		this.imageCache.add( new Image( "images/wallet.png" ) );
		this.imageCache.add( new Image( "images/jacket.png" ) );
		this.imageCache.add( new Image( "images/pda.png" ) );
		this.imageCache.add( new Image( "images/bike-helmet.png" ) );
		this.imageCache.add( new Image( "images/camera.png" ) );
		
		
		this.people = new Vector<Person>();
		int id      = 1;
		
		this.people.add( new Person("Alice"      , id++, "Alice"    , "images/person-orange.png") );
		this.people.add( new Person("James"      , id++, "James"    , "images/person-blue.png") );
		this.people.add( new Person("Nikhil"     , id++, "Nikhil", "images/person-red.png"  ) );
		this.people.add( new Person("Prof. Chen" , id++, "Prof. Chen", "images/person-pink.png"  ) );

		
//		this.people.add( new Person("Evan"       , id++, "Evan"       , "images/person-blue-green.png") );
//		this.people.add( new Person("Gaetano"    , id++, "Gaetano"    , "images/person-orange.png") );
		
//		this.people.add( new Person("Magda"      , id++, "Magda"      , "images/person-red.png") );
		
//      this.people.add( new Person("me"      , id++, "me"      , "images/person-orange.png") );
      
//      this.people.add( new Person("Custodian Dave"  , id++, "Custodian Dave"  , "images/person-red.png"   ) );
//      this.people.add( new Person("Me"         , id++, "Me"         , "images/person-pink.png"  ) );
//      this.people.add( new Person("Prof. Silverman", id++, "Prof. Silverman", "images/person-purple.png") );
      
//      this.people.add( new Person("Support Staff Member" , id++, "Support Staff Member" , "images/person-blue-green.png"  ) );
      
		this.personGrps = new Vector<PersonGrp>();
		this.personGrps.add( new PersonGrp("Professors", id++, "Professors", "images/group-person-orange.png") );
		this.personGrps.add( new PersonGrp("Students"  , id++, "Students", "images/group-person-blue.png") );
		this.personGrps.add( new PersonGrp("PhDs"      , id++, "PhDs", "images/group-person-blue-green.png") );
		this.personGrps.add( new PersonGrp("Database"  , id++, "Database", "images/group-person-pink.png") );
		
		this.things = new Vector<Thing>();
		
		this.things.add( new Thing("Alice's algorithms notes" , id++, "Alice's algorithms notes", "images/notebook.png") );
		this.things.add( new Thing("James' algorithms notes" , id++, "James' algorithms notes", "images/notebook.png") );
		this.things.add( new Thing("Bike Helmet"       , id++, "Bike Helmet", "images/bike-helmet.png") );
		
//		this.things.add( new Thing("Coffee mug"        , id++, "Coffee mug", "images/mug.png") );
//		this.things.add( new Thing("Prof. Chen's Book" , id++, "Prof. Chen's Book", "images/book.png") );
//		this.things.add( new Thing("Bob's Backpack"    , id++, "Backpack", "images/backpack.png") );
//		this.things.add( new Thing("Bob's iPod"        , id++, "iPod", "images/ipod.png") );
//		this.things.add( new Thing("Car keys"    , id++, "Car keys", "images/keys.png") );
//		this.things.add( new Thing("My Laptop"    , id++, "My Laptop", "images/laptop.png") );
//		this.things.add( new Thing("Custodian's Mop"   , id++, "Custodian's Mop", "images/mop.png") );
//		this.things.add( new Thing("Database notebook" , id++, "Database notebook", "images/notebook.png") );
//		this.things.add( new Thing("Umbrella"          , id++, "Umbrella", "images/umbrella.png") );
//		this.things.add( new Thing("Wallet"            , id++, "Wallet", "images/wallet.png") );
//		this.things.add( new Thing("Jacket"            , id++, "Jacket", "images/jacket.png") );
//		this.things.add( new Thing("Linux Workstation" , id++, "Linux Workstation", "images/pc.png") );
//		this.things.add( new Thing("Windows Workstation" , id++, "Windows Workstation", "images/pc.png") );
//		
//		this.things.add( new Thing("PDA"               , id++, "PDA", "images/pda.png") );
//		this.things.add( new Thing("Bike Helmet"       , id++, "Bike Helmet", "images/bike-helmet.png") );
//		this.things.add( new Thing("Camera"            , id++, "Camera", "images/camera.png") );
		
		this.thingGrps = new Vector<ThingGrp>();
		this.thingGrps.add( new ThingGrp("Gym gear"        , id++, "Gym gear", "images/group-object-orange.png") ); 
		this.thingGrps.add( new ThingGrp("Meeting supplies", id++, "Meeting supplies", "images/group-object-blue.png") );
		this.thingGrps.add( new ThingGrp("Biking gear"     , id++, "Biking gear", "images/group-object-pink.png") );
		this.thingGrps.add( new ThingGrp("Study materials" , id++, "Study materials", "images/group-object-red.png") );
		
		this.places = new Vector<Place>();
		
		
		this.places.add( new Place("Alice and Nikhil's Office", id++, "Alice and Nikhil's Office", "images/place-pixel.png") );		
		this.places.add( new Place("James' Office"       , id++, "James' office"      , "images/place-pixel.png") );
		this.places.add( new Place("Prof. Chen's Office" , id++, "Prof. Chen's Office" , "images/place-pixel.png") );
		this.places.add( new Place("Lab"                 , id++, "Lab"                 , "images/place-pixel.png") );
		
//		this.places.add( new Place("Magda's Office"      , id++, "Magda's office"      , "images/place-pixel.png") );
//		this.places.add( new Place("Evan's Office"       , id++, "Evan's office"      , "images/place-pixel.png") );
//		this.places.add( new Place("Building"            , id++, "Building"            , "images/place-pixel.png") );
//		this.places.add( new Place("Alice's Office"      , id++, "Alice's Office"      , "images/place-pixel.png") );
//		this.places.add( new Place("Lab"                 , id++, "Lab"                 , "images/place-pixel.png") );
//		this.places.add( new Place("My Office"         , id++, "My Office"         , "images/place-pixel.png") );
//		this.places.add( new Place("Prof. Chen's Office" , id++, "Prof. Chen's Office" , "images/place-pixel.png") );
//		this.places.add( new Place("Prof. Silverman's Office", id++, "Prof. Silverman's Office", "images/place-pixel.png") );
//		this.places.add( new Place("Custodial Closet"  , id++, "Custodial Closet"  , "images/place-pixel.png") );
//		this.places.add( new Place("Linux Expert\'s Office"  , id++, "Linux Expert\'s Office"  , "images/place-pixel.png") );
//		this.places.add( new Place("Windows Expert\'s Office"  , id++, "Windows Expert\'s Office"  , "images/place-pixel.png") );
//		this.places.add( new Place("Support Office"  , id++, "Support Office"  , "images/place-pixel.png") );
//		this.places.add( new Place("Loading Dock"  , id++, "Loading Dock"  , "images/place-pixel.png") );
//      this.places.add( new Place("Conference Room"     , id++, "Conference Room"     , "images/place-pixel.png") );
//      this.places.add( new Place("Bike Room"     , id++, "Bike Room"     , "images/place-pixel.png") );
		
//		this.places.add( new Place("Lab"                 , id++, "Lab"                 , "images/place-pixel.png") );
//		this.places.add( new Place("Coffee Stand"        , id++, "Coffee Stand"        , "images/place-pixel.png") );
//		this.places.add( new Place("Student Lounge"      , id++, "Lounge"              , "images/place-pixel.png") );
//		this.places.add( new Place("Printer Room"        , id++, "Printer Room"        , "images/place-pixel.png") );		
		
//		this.places.add( new Place("Undergrad Lab", id++, "Undergrad Lab", "images/place-pixel.png") );
//		this.places.add( new Place("Lunch Room (4th floor)", id++, "Lunch Room (4th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Printer (4th floor)", id++, "Printer (4th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Coffee Room (4th floor)", id++, "Coffee Room (4th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Lunch Room (5th floor)", id++, "Lunch Room (5th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Printer (5th floor)", id++, "Printer (5th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Coffee Room (5th floor)", id++, "Coffee Room (5th floor)", "images/place-pixel.png") );
//		this.places.add( new Place("Mia's office (CSE 550)", id++, "Mia's office (CSE 550)", "images/place-pixel.png") );
	}
	
	
	public Vector<Person> getPersons(){
		return this.people;
	}
	
	public Vector<PersonGrp> getPersonGrps(){
		return this.personGrps;
	}
	
	public Vector<Thing> getThings(){
		return this.things;
	}
	
	public Vector<ThingGrp> getThingGrps(){
		return this.thingGrps;
	}
	
	public Vector<Place> getPlaces(){
		return this.places;
	}
}
