package edu.washington.cs.rfid.cascadia.scenic.client.ui.factory;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.PushButton;

import edu.washington.cs.rfid.cascadia.scenic.client.ui.SequencePanel;
import edu.washington.cs.rfid.cascadia.scenic.client.ui.Transition;

public class TransitionFactory {

   // Normal sizing
   protected static final int    WIDTH_INITIAL_TRANSITION = 60;
   protected static final int    WIDTH_NEXT_TRANSITION    = 60;
   protected static final int    WIDTH_BEFORE_TRANSITION  = 100;
   protected static final int    HEIGHT_TRANSITION        = 340;
   
   protected static final String IMG_ERROR_WARNING        = "images/under-construction.png";
   protected static final String IMG_TIME_WEDGE           = "images/time-wedge.png";
   
   protected static final int    WIDTH_IMG_ERROR_WARNING  = 20;
   protected static final int    HEIGHT_IMG_ERROR_WARNING = 25;
   protected static final int    WIDTH_IMG_TIME_WEDGE     = 25;
   protected static final int    HEIGHT_IMG_TIME_WEDGE    = 39;
   
   //--//
   
   protected static int transitionNum = 0;
   
   //--//
   
   /**
    * Creates a new transition for the specified sequence panel.
    * @return
    */
   public static Transition createTransition(SequencePanel parentSequence){
      
      Image timeWedgeImg = new Image(TransitionFactory.IMG_TIME_WEDGE);
      timeWedgeImg.setPixelSize(TransitionFactory.WIDTH_IMG_TIME_WEDGE,
                                TransitionFactory.HEIGHT_IMG_TIME_WEDGE);
      PushButton timeWedgeButton = new PushButton(timeWedgeImg);
      
      Image errorWarningImg = new Image(TransitionFactory.IMG_ERROR_WARNING);
      
      Button timingChangeButton = new Button("Set!");
      
      Transition t = new Transition(parentSequence,
                                    TransitionFactory.WIDTH_INITIAL_TRANSITION,
                                    TransitionFactory.HEIGHT_TRANSITION,
                                    timeWedgeButton,
                                    errorWarningImg,
                                    timingChangeButton,
                                    false);
      return t;
   }
   
   
   public static Transition createThumbnailTransition(SequencePanel parentSequence){
      
      Image timeWedgeImg = new Image(TransitionFactory.IMG_TIME_WEDGE);
      int width  = (int)(TransitionFactory.WIDTH_IMG_TIME_WEDGE/SequenceFactory.THUMBNAIL_FACTOR);
      int height = (int)(TransitionFactory.HEIGHT_IMG_TIME_WEDGE/SequenceFactory.THUMBNAIL_FACTOR);
      timeWedgeImg.setPixelSize(width,height);
      
      PushButton timeWedgeButton = new PushButton(timeWedgeImg);
      
      Image errorWarningImg = new Image(TransitionFactory.IMG_ERROR_WARNING);
      width  = (int)(TransitionFactory.WIDTH_IMG_ERROR_WARNING/SequenceFactory.THUMBNAIL_FACTOR);
      height = (int)(TransitionFactory.HEIGHT_IMG_ERROR_WARNING/SequenceFactory.THUMBNAIL_FACTOR);
      errorWarningImg.setPixelSize(width,height);
      
      Button timingChangeButton = new Button("Set!");
      
      width  = (int)(TransitionFactory.WIDTH_INITIAL_TRANSITION/SequenceFactory.THUMBNAIL_FACTOR);
      height = (int)(TransitionFactory.HEIGHT_TRANSITION/SequenceFactory.THUMBNAIL_FACTOR);
      
      Transition t = new Transition(parentSequence,
                                    width,
                                    height,
                                    timeWedgeButton,
                                    errorWarningImg,
                                    timingChangeButton,
                                    true);
      return t;
   }
}
