package edu.washington.cs.rfid.cascadia.scenic.client.util;

import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.VerticalPanel;

public class ImageUtility {

   /**
    * Rescale an image according to the constraints you want.  Assumes that the image
    * is already inserted somewhere.
    * 
    *  Note: this does not work in IE because the image does not load and even with
    *  the onLoad listener, the returned width and height are 0
    */
   public static void rescaleImage(final Image img, final int maxWidth, final int maxHeight) {
      
      DeferredRescaleCheckCommand cmd = new DeferredRescaleCheckCommand(img, maxWidth, maxHeight);
      DeferredCommand.addCommand(cmd);
      
      // addLoadHandler and addErrorHandler
      img.addLoadHandler(new RescalingLoadListener(maxWidth, maxHeight, cmd));
   }
   
   
   /**
    * Rescale an image according to the constraints you want.  Once the image is rescaled, 
    * it is inserted into the specified VerticalPanel at the specified index.
    * 
    *  Note: this does not work in IE because the image does not load and even with
    *  the onLoad listener, the returned width and height are 0
    */
   public static void rescaleImage(final Image           img,
                                   final int             maxWidth,
                                   final int             maxHeight,
                                   final HorizontalPanel hp,
                                   final int             hpIndex) {
      
      DeferredRescaleCheckCommand cmd = new DeferredRescaleCheckCommand(img, maxWidth, maxHeight, hp, hpIndex);
      DeferredCommand.addCommand(cmd);
      
      img.addLoadHandler(new RescalingLoadListener(maxWidth, maxHeight, cmd, hp, hpIndex));
   }

   
   /**
    * Rescale an image according to the constraints you want.  Once the image is rescaled, 
    * it is inserted into the specified VerticalPanel at the specified index.
    * 
    *  Note: this does not work in IE because the image does not load and even with
    *  the onLoad listener, the returned width and height are 0
    */
   public static void rescaleImage(final Image         img,
                                   final int           maxWidth,
                                   final int           maxHeight,
                                   final VerticalPanel vp,
                                   final int           vpIndex) {
      
      DeferredRescaleCheckCommand cmd = new DeferredRescaleCheckCommand(img, maxWidth, maxHeight, vp, vpIndex);
      DeferredCommand.addCommand(cmd);

      img.addLoadHandler(new RescalingLoadListener(maxWidth, maxHeight, cmd, vp, vpIndex));
   }
   
   
   /**
    * Rescale an image according to the constraints you want.  Once the image is rescaled, 
    * it is inserted into the specified VerticalPanel at the specified index.
    * 
    *  Note: this does not work in IE because the image does not load and even with
    *  the onLoad listener, the returned width and height are 0
    */
   public static void rescaleImage(final Image         img,
                                   final int           maxWidth,
                                   final int           maxHeight,
                                   final AbsolutePanel ap,
                                   final int           x,
                                   final int           y) {
      
      DeferredRescaleCheckCommand cmd = new DeferredRescaleCheckCommand(img, maxWidth, maxHeight, ap, x, y);
      DeferredCommand.addCommand(cmd);

      img.addLoadHandler(new RescalingLoadListener(maxWidth, maxHeight, cmd, ap, x, y));
   }
}