package edu.washington.cs.rfid.cascadia.scenic.client.util;

import com.google.gwt.user.client.Element;

/**
 * A class to help with native JavaScript methods.
 * @author evan
 */
public class JavaScriptHelper {
   
   public static void disableTextSelection(Element elem, boolean disable) {
      disableTextSelectInternal(elem, disable);
   }

   
   private native static void disableTextSelectInternal(Element e, boolean disable)/*-{
      if (disable) {
         e.ondrag        = function () { return false; };
         e.onselectstart = function () { return false; };
         
         if (typeof e.style.MozUserSelect!="undefined") {
            e.style.MozUserSelect="none"
         }
      } else {
         e.ondrag = null;
         e.onselectstart = null;
      }
   }-*/;
    
   
   public static void makePngTransparent(Element elem){
      makePngTransparentInternal(elem);
   }
   
   
   private native static void makePngTransparentInternal(Element myImage) /*-{
            
      var arVersion = navigator.appVersion.split("MSIE")
      var version   = parseFloat(arVersion[1])
            
      if ((version >= 5.5) && (version < 7) && (document.body.filters)) {
         var imgID      = (myImage.id) ? "id='" + myImage.id + "' " : ""
         var imgClass   = (myImage.className) ? "class='" + myImage.className + "' " : ""
         var imgTitle   = (myImage.title) ? 
                                        "title='" + myImage.title  + "' " : "title='" + myImage.alt + "' "
         var imgStyle      = "display:inline-block;" + myImage.style.cssText
         var strNewHTML    = "<span " + imgID + imgClass + imgTitle
                             + " style=\"" + "width:" + myImage.width 
                             + "px; height:" + myImage.height 
                             + "px;" + imgStyle + ";"
                             + "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
                             + "(src=\'" + myImage.src + "\', sizingMethod='scale');\"></span>"
         myImage.outerHTML = strNewHTML          
      }            
   }-*/;
    
   
   public static void disableContextMenu(Element elem, boolean disable){
      disableContextMenuInternal(elem,disable);
   }
    
   
   private native static void disableContextMenuInternal(Element e, boolean disable)/*-{
      if (disable){
         e.oncontextmenu = function() {
            return false;
         }
      } else {
         e.oncontextmenu = function() {
            return true;
         }
      }
   }-*/;
}
