package edu.washington.cs.rfid.cascadia.timeline.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException;
import com.google.gwt.user.client.rpc.InvocationException;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.RootPanel;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;
import edu.washington.cs.rfid.cascadia.timeline.client.ui.ScenicTimelinePanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class TimelineWidget { //implements EntryPoint {

   /**
    * Create a remote service proxy to talk to the server-side Greeting service.
    */
   private final GreetingServiceAsync greetingService = GWT.create(GreetingService.class);


   //--//
   
   protected ScenicTimelinePanel panel;
   protected int                 taskNum;
   
   //--//
   
   /**
    * This is the entry point method.
    */
   public void onModuleLoad() {
      HorizontalPanel hp = new HorizontalPanel();
      hp.setWidth("100%");
      hp.setHorizontalAlignment(HorizontalPanel.ALIGN_CENTER);
      
      this.panel   = null;
      this.taskNum = -1;
      
      Button nextTaskButton = new Button("Next Task");
      nextTaskButton.addClickHandler(new ClickHandler(){
         public void onClick(ClickEvent e){
            taskNum++;
            greetingService.getResultBundle(taskNum,getBundleCallback);
         }
      });
      hp.add(nextTaskButton);
      hp.setCellHorizontalAlignment(nextTaskButton, HorizontalPanel.ALIGN_CENTER);
      RootPanel.get().add(hp);
   }
   
   
   
   private final AsyncCallback<ScenicEventResultBundle> getBundleCallback = 
      new AsyncCallback<ScenicEventResultBundle>() {

      public void onSuccess(ScenicEventResultBundle result) {
         if(null != result){
            if(null != panel){
               RootPanel.get().remove(panel);
            }
            panel = ScenicTimelinePanel.getInstance(result);
            RootPanel.get().add(panel);
         }
      }

      public void onFailure(Throwable caught) {
         // Convenient way to find out which exception was thrown.
         try {
            throw caught;
         } catch (IncompatibleRemoteServiceException e) {
            // this client is not compatible with the server; cleanup and refresh the browser
         } catch (InvocationException e) {
            // the call didn't complete cleanly
         } catch (Throwable e) {
            // last resort -- a very unexpected exception
         }
      }
   };
}
