package edu.washington.cs.rfid.cascadia.timeline.client.highlighter;

import java.util.List;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class EventTreeHighlighter implements IScenicHighlighter {

   public List<ScenicTimelineEvent> eventStream;
   
   //--//
   
   /**
    * Creates a new EventTreeHighlighter.
    * @param eventStream
    */
   public EventTreeHighlighter(List<ScenicTimelineEvent> eventStream){
      this.eventStream = eventStream;
   }
   
   
   /**
    * Highlights an event if it's in this highlighter's set of events.
    */
   public int getHighlightingIndex(ScenicTimelineEvent event){
      int    index = -1;
      String id    = event.eventId;
      
      for(ScenicTimelineEvent e : this.eventStream){
         if(e.eventId.equals(id)){
            index = 0;   // For now highlight all with the same color
            break;
         }
      }
      return index;
   }
}
