package edu.washington.cs.rfid.cascadia.timeline.server;

import java.util.Vector;

import edu.washington.cs.rfid.cascadia.scenic.client.data.EventTask;

public class TaskManager {

   private Vector<EventTask> tasks;
   
   //--//
   
   /**
    * Creates a new TaskManager.
    */
   public TaskManager(){
      this.tasks = new Vector<EventTask>();
      this.loadTasks();
   }


   /**
    * Gets the event task after the specified one and returns it.
    */
   public EventTask nextEventTask(int numCurTask){
      EventTask task = null;
      
      if(numCurTask <= this.tasks.size()){
         task = this.tasks.get(numCurTask - 1);
      }
      
      return task;
   }
   
   //--//
   
   /**
    * Load all six event tasks.
    */
   private void loadTasks(){
      
      int    eventNum      = 1;
      String application   = "<i>Context-Aware Notifications</i>.  This application allows users to be notified " +
                             "(e.g., by email or SMS) when a particular event occurs.";
      String usageScenario = "Prof. Chen has been in and out of her office today and you need to talk to her but " +
                             "arent sure when to stop by her office.<br>" + 
                             "<i>Please specify an event that will help you decide.</i>";
      
      EventTask task1 = new EventTask(eventNum, application, usageScenario);
      
      
      eventNum      = 2;
      application   = "<i>Context-Aware Meeting Support</i>.  This application can dynamically adjust the conference " +
                      "room when it detects a meeting in that room.";
      usageScenario = "You regularly have large group meetings in the conference room including You, Alice, Bob, Prof. Chen " +
                      "and Prof. Silverman.  For every meeting youd like the context-aware meeting support application to " +
                      "turn on the projector and keep it on as long as everyone is in the room.<br>" +
                      "<i>Please specify an event that can be used to keep the projector on</i>.";
      
      
      EventTask task2 = new EventTask(eventNum, application, usageScenario);
      
      eventNum      = 3;
      application   = "<i>Anti-Theft Application</i>.  This application detects thefts and alerts you and your buildings " +
                      "security personnel whenever a theft occurs.";
      usageScenario = "Youd like to use the anti-theft application to protect your new laptop.  In particular, youre " +
                      "worried about your laptop being stolen from your office while you are working in the lab.<br>" + 
                      "<i>Please specify an event that the anti-theft application can use to alert you if such a theft occurs</i>.";
      
      
      EventTask task3 = new EventTask(eventNum, application, usageScenario);
      
      eventNum      = 4;
      application   = "<i>Digital Diary</i>.  This application detects events and records them in a personal digital " +
                      "diary so that you can review your activities later.";
      usageScenario = "Youre working on a lab project with your teammates Alice and Bob.  When the project is complete youd like " +
                      "to use the Personal Diary Recorder to review your groups work habits during the project.  In particular, " +
                      "youre interested in what time each lab meeting started throughout the project<br>" +
                      "<i>Please specify the appropriate event for the Digital Diary</i>.";

      
      EventTask task4 = new EventTask(eventNum, application, usageScenario);
      
      eventNum      = 5;
      application   = "<i>Workflow Monitoring Application</i>.  This application detects everyday workflows and records them in a log.  " +
                      "That log can later be reviewed so that a workforce can assess and optimize its performance on the tasks it carries out.";
      usageScenario = "Your buildings custodial team always mops the lab floor as the last task before returning the mop to the custodial " +
                      "closet and heading home for the day.  To assess their performance, the team is interested in recording what time " +
                      "custodians finish their tasks and head home each day.<br>" +
                      "<i>Please specify an event that can be used to record every time Custodian Dave finished for the day</i>.";

      
      EventTask task5 = new EventTask(eventNum, application, usageScenario);
      
      eventNum      = 6;
      application   = "<i>Workflow Monitoring Application</i>.  This application detects everyday workflows and records them in a log.  " +
                      "That log can later be reviewed so that a workforce can assess and optimize its performance on the tasks it carries out.";
      usageScenario = "Your buildings computer support team wants to track every time it receives, prepares and deploys a new workstation in " +
                      "the lab.  This process involves the following steps:<br><br>" + 
                      "1) A support staff member moves a workstation from the loading dock to the support office where it will be unpacked.<br><br>" +

                      "2) If the workstation runs Linux, it must be taken to the Linux experts office for further configuration.  " +
                      "Alternatively, if the workstation runs Windows, it must be taken to the Windows experts office for further configuration " +
                      "and then back to the support office where more Windows software will be installed.<br><br>" +   

                      "3) After configuration (and possibly further Windows software installation), the workstation is moved by a support staff " +
                      "member to the lab.<br><br>" + 
                      "<i>Please specify an event that can be used to record every time the computer support team receives, prepares and deploys" +
                      " a new workstation in the lab.</i>.";
                        
      EventTask task6 = new EventTask(eventNum, application, usageScenario);
      
      
      this.tasks.add(task1);
      this.tasks.add(task2);
      this.tasks.add(task3);
      this.tasks.add(task4);
      this.tasks.add(task5);
      this.tasks.add(task6);
   }
}
