package edu.washington.cs.rfid.cascadia.timeline.server.data;

import java.util.ArrayList;
import java.util.HashMap;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicCompleteEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class AliceHelmetResultLibrary {
   
   public static String[] colors = new String[]{"#ffcc00",
                                                "#3366cc",
                                                "#00ffff",
                                                "#ffccff",
                                                "#cc33ff",
                                                "#ff3333",
                                                "#cccc33"};
   public static int trackNum = 1;
   public static int eventId  = 0;

   //--//

   public static ScenicEventResultBundle getResultBundle(int taskNum, String xml){

      HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap = new HashMap<String,ArrayList<ScenicTimelineEvent>>();
      ScenicCompleteEventResult                      completeResult = null;
      
      
      int                            streamKey = 0;
      ArrayList<ScenicTimelineEvent> stream    = null;
      ArrayList<ScenicEventResult>   modelData = new ArrayList<ScenicEventResult>();
      ScenicTimelineEvent            e         = null;
      ScenicEventResult              result    = null;
      
      
      // BUILD SCENES-----------------------------------------------------------------------------
      ArrayList<ScenicEventResult> sceneEvents = new ArrayList<ScenicEventResult>();
      ArrayList<ScenicEventResult> primitiveEvents = null;
      
      //----------- SCENE ONE --------------

      // Scene 1, Primitive 1 - ALICE WITH HELMET
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneOneWithHelmetStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Scene 1, Primitive 2 - ALICE OUTSIDE
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneOneAliceOutsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneOneEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);
      
      

      
      //----------- SCENE TWO --------------

      // Scene 2, Primitive 1 - ALICE INSIDE
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneTwoAliceInsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Scene 2, Primitive 2 - ALICE WITH HELMET
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneTwoWithHelmetStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = AliceHelmetResultLibrary.getSceneTwoEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);

      
      // BUILD SUBSEQUENCES-----------------------------------------------------------------------------
      
      ArrayList<ScenicEventResult> subSequenceEvents = new ArrayList<ScenicEventResult>();
      
      
      streamKey++;
      stream = AliceHelmetResultLibrary.getSecondSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      streamKey++;
      stream = AliceHelmetResultLibrary.getFirstSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      
      
      // BUILD COMPLETE EVENT-----------------------------------------------------------------------------
      
      streamKey++;
      stream = AliceHelmetResultLibrary.getCompleteEventStream();
      keyToStreamMap.put("" + streamKey,stream);
      
      e      = stream.get(0);

      completeResult = new ScenicCompleteEventResult(e.title, 
                                           e.description, 
                                           "" + streamKey, 
                                           sceneEvents, 
                                           subSequenceEvents);
      
      
      
      return new ScenicEventResultBundle(xml, "Wed, 23 Sep 2009 9:05:02 +0000", completeResult, keyToStreamMap);
   }

 
   
   
   
   
   //------------------------------ EVENT CREATION ------------------------------------------------------------


   public static ArrayList<ScenicTimelineEvent> getCompleteEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:42 +0000","Thu, 24 Sep 2009 10:40:42 +0000","Fri, 25 Sep 2009 9:10:42 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:03:52 +0000","Thu, 24 Sep 2009 10:40:52 +0000","Fri, 25 Sep 2009 9:10:52 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[0], 
            "Event", 
            "Alice enters her office with her bike helmet");
   }

   public static ArrayList<ScenicTimelineEvent> getFirstSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:05 +0000",
            "Thu, 24 Sep 2009 10:40:05 +0000",
            "Fri, 25 Sep 2009 9:10:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:14 +0000",
            "Thu, 24 Sep 2009 10:42:13 +0000",
            "Fri, 25 Sep 2009 9:12:13 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[1], 
            "Scenes 1", 
            "Scenes 1");
   }
   
   public static ArrayList<ScenicTimelineEvent> getSecondSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:42 +0000","Thu, 24 Sep 2009 10:40:42 +0000","Fri, 25 Sep 2009 9:10:42 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:03:52 +0000","Thu, 24 Sep 2009 10:40:52 +0000","Fri, 25 Sep 2009 9:10:52 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[1], 
            "Scenes 1,2", 
            "Scenes 1,2");
   }
   

   
   //******************************SCENE ONE***********************************************

   public static ArrayList<ScenicTimelineEvent> getSceneOneEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:05 +0000",
            "Thu, 24 Sep 2009 10:40:05 +0000",
            "Fri, 25 Sep 2009 9:10:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:14 +0000",
            "Thu, 24 Sep 2009 10:42:13 +0000",
            "Fri, 25 Sep 2009 9:12:13 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[4],
            "Scene 1", 
            "Alice is outside her office with her bike helmet");
   }
   

   public static ArrayList<ScenicTimelineEvent> getSceneOneAliceOutsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:05 +0000","Wed, 23 Sep 2009 9:05:14 +0000",
                                    "Thu, 24 Sep 2009 10:40:05 +0000","Thu, 24 Sep 2009 10:42:13 +0000",
                                    "Fri, 25 Sep 2009 9:10:05 +0000","Fri, 25 Sep 2009 9:12:13 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:03:41 +0000","Wed, 23 Sep 2009 9:08:44 +0000",
                                    "Thu, 24 Sep 2009 10:40:41 +0000","Thu, 24 Sep 2009 10:45:43 +0000",
                                    "Fri, 25 Sep 2009 9:10:41 +0000","Fri, 25 Sep 2009 9:15:43 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[4],
            "Alice is outside Alice's office", 
            "Alice is outside Alice's office");
   }
   
   
   public static ArrayList<ScenicTimelineEvent> getSceneOneWithHelmetStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:05 +0000",
                                    "Thu, 24 Sep 2009 10:40:05 +0000",
                                    "Fri, 25 Sep 2009 9:10:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:14 +0000",
                                    "Thu, 24 Sep 2009 10:42:13 +0000",
                                    "Fri, 25 Sep 2009 9:12:13 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[4],
            "Alice is with her helmet", 
            "Alice is with her helmet");
   }

   
   
   //******************************SCENE TWO***********************************************

   public static ArrayList<ScenicTimelineEvent> getSceneTwoEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:42 +0000","Thu, 24 Sep 2009 10:40:42 +0000","Fri, 25 Sep 2009 9:10:42 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:12 +0000","Thu, 24 Sep 2009 10:42:12 +0000","Fri, 25 Sep 2009 9:12:12 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[5],
            "Scene 2", 
            "Alice is with her helmet inside Alice's office");
   }
   
   
   public static ArrayList<ScenicTimelineEvent> getSceneTwoAliceInsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:42 +0000","Thu, 24 Sep 2009 10:40:42 +0000","Fri, 25 Sep 2009 9:10:42 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:12 +0000","Thu, 24 Sep 2009 10:42:12 +0000","Fri, 25 Sep 2009 9:12:12 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[5], 
            "Alice is inside her office", 
            "Alice is inside her office");
   }

   
   public static ArrayList<ScenicTimelineEvent> getSceneTwoWithHelmetStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:05 +0000",
                                    "Thu, 24 Sep 2009 10:40:05 +0000",
                                    "Fri, 25 Sep 2009 9:10:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:05:14 +0000",
                                    "Thu, 24 Sep 2009 10:42:13 +0000",
                                    "Fri, 25 Sep 2009 9:12:13 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[5],
            "Alice is with her helmet", 
            "Alice is with her helmet");
   }
   
   
   public static ArrayList<ScenicTimelineEvent> getSceneTwoHelmetInsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 9:03:42 +0000","Thu, 24 Sep 2009 10:40:42 +0000","Fri, 25 Sep 2009 9:10:42 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 9:08:44 +0000","Thu, 24 Sep 2009 10:45:43 +0000","Fri, 25 Sep 2009 9:15:43 +0000"};

      return AliceHelmetResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceHelmetResultLibrary.colors[5], 
            "Alice's helmet is inside her office", 
            "Alice's helmet is inside her office");
   }
   
   
   
   
   //--//

   /**
    * Generates a stream given the parameters for each event.
    * @param start
    * @param stop
    * @param durationEvent
    * @param color
    * @param textColor
    * @param title
    * @param description
    * @param icon
    * @param image
    * @param html
    * @param trackNum
    * @return
    */
   public static ArrayList<ScenicTimelineEvent> generateEventStream(String[] start        , 
         String[] stop         ,
         String   durationEvent,
         String   color        ,
         String   title        ,
         String   description){
      ArrayList<ScenicTimelineEvent> stream = new ArrayList<ScenicTimelineEvent>();

      for(int i = 0; i < start.length; i++){
         ScenicTimelineEvent e = new ScenicTimelineEvent();
         e.start         = start[i];
         e.end           = stop[i];
         e.durationEvent = "false";
         e.color         = color;
         e.textColor     = "#000000";
         e.title         = title;
         e.description   = description;
         e.icon          = "../images/green-circle.png";
         e.image         = "../images/green-circle.png";
         e.html          = description;
         e.trackNum      = trackNum;
         e.eventId       = "" + AliceHelmetResultLibrary.eventId++;
         stream.add(e);
      }

      return stream;
   }
   

}
