package edu.washington.cs.rfid.cascadia.timeline.server.data;

import java.util.ArrayList;
import java.util.HashMap;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicCompleteEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class AliceOverSpecifiedMeetingLibrary {


   public static String[] colors = new String[]{"#ffcc00",
                                                "#3366cc",
                                                "#00ffff",
                                                "#ffccff",
                                                "#cc33ff",
                                                "#ff3333",
                                                "#cccc33"};
   public static int trackNum = 1;
   public static int eventId  = 0;

   //--//

   public static ScenicEventResultBundle getResultBundle(int taskNum, String xml){

      HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap = new HashMap<String,ArrayList<ScenicTimelineEvent>>();
      ScenicCompleteEventResult                      completeResult = null;
      
      
      int                            streamKey = 0;
      ArrayList<ScenicTimelineEvent> stream    = null;
      ArrayList<ScenicEventResult>   modelData = new ArrayList<ScenicEventResult>();
      ScenicTimelineEvent            e         = null;
      ScenicEventResult              result    = null;
      
      
      // BUILD SCENES-----------------------------------------------------------------------------
      ArrayList<ScenicEventResult> sceneEvents = new ArrayList<ScenicEventResult>();
      ArrayList<ScenicEventResult> primitiveEvents = null;
      
      //----------- SCENE ONE --------------

      
      // Primitive 1 - Alice inside office
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneOneAliceInsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneOneEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);
      
      

      
      //----------- SCENE TWO --------------

      // Primitive 1
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneTwoAliceOutsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneTwoEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);

      
      
      //-------------- SCENE TWO ---------------
      
      // Primitive 1
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneThreeAllInsideLabStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSceneThreeEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);
      
      
      // BUILD SUBSEQUENCES-----------------------------------------------------------------------------
      
      ArrayList<ScenicEventResult> subSequenceEvents = new ArrayList<ScenicEventResult>();
      
      
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getSecondSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getFirstSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      
      
      // BUILD COMPLETE EVENT-----------------------------------------------------------------------------
      
      streamKey++;
      stream = AliceOverSpecifiedMeetingLibrary.getCompleteEventStream();
      keyToStreamMap.put("" + streamKey,stream);
      
      e      = stream.get(0);

      completeResult = new ScenicCompleteEventResult(e.title, 
                                           e.description, 
                                           "" + streamKey, 
                                           sceneEvents, 
                                           subSequenceEvents);
      
      
      
      return new ScenicEventResultBundle(xml, "Wed, 23 Sep 2009 11:00:05 +0000", completeResult, keyToStreamMap);
   }

 
   
   
   
   
   
   
   
   
   
   //------------------------------ EVENT CREATION ------------------------------------------------------------


   public static ArrayList<ScenicTimelineEvent> getCompleteEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:04:22 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:05:05 +0000"};
      
      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[0], 
            "Event", 
            "Alice leaves her office to meet Nikhil and Prof. Chen in the lab");
   }

   public static ArrayList<ScenicTimelineEvent> getFirstSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000"};

      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[0], 
            "Scenes 1", 
            "Scenes 1");
   }
   
   public static ArrayList<ScenicTimelineEvent> getSecondSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:00:42 +0000"};
      
      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[0], 
            "Scenes 1,2", 
            "Scenes 1,2");
   }
   
   
   //******************************SCENE ONE******************************************

   public static ArrayList<ScenicTimelineEvent> getSceneOneEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000"};

      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[4],
            "Scene 1", 
            "Alice is inside her office");
   }

   
   // Scene 1, Primitive 1 - ALICE INSIDE OFFICE
   public static ArrayList<ScenicTimelineEvent> getSceneOneAliceInsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000"};

      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[4],
            "Alice is inside her office", 
            "Alice is inside her office");
   }
   
   
   //******************************SCENE TWO******************************************

   public static ArrayList<ScenicTimelineEvent> getSceneTwoEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000","Fri, 25 Sep 2009 11:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:05:30 +0000","Fri, 25 Sep 2009 11:05:30 +0000"};
      
      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[5],
            "Scene 2", 
            "Alice is outside her office.");
   }

   
   // Scene 2, Primitive 1 - ALICE OUTSIDE HER OFFICE
   public static ArrayList<ScenicTimelineEvent> getSceneTwoAliceOutsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:00:32 +0000","Fri, 25 Sep 2009 11:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:05:30 +0000","Fri, 25 Sep 2009 11:05:30 +0000"};
      
      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[5], 
            "Alice is outside her office.", 
            "Alice is outside her office.");
   }
   
   
   
   //******************************SCENE THREE******************************************
   
   public static ArrayList<ScenicTimelineEvent> getSceneThreeEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:04:22 +0000","Fri, 25 Sep 2009 11:04:00 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:05:30 +0000","Fri, 25 Sep 2009 11:05:30 +0000"};
      
      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[6],
            "Scene 3", 
            "Alice is in the lab with Nikhil and Prof. Chen.");
   }
   
   
   // Scene 3, Primitive 1 - ALICE, NIKHIL AND PROF CHEN ARE INSIDE THE LAB
   public static ArrayList<ScenicTimelineEvent> getSceneThreeAllInsideLabStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 11:04:22 +0000","Fri, 25 Sep 2009 11:04:00 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 11:05:30 +0000","Fri, 25 Sep 2009 11:05:30 +0000"};

      return AliceOverSpecifiedMeetingLibrary.generateEventStream(start, 
            stop, 
            "true", 
            AliceOverSpecifiedMeetingLibrary.colors[6],
            "Alice, Nikhil and Prof. Chen are inside the Lab", 
            "Alice, Nikhil and Prof. Chen are inside the Lab");
   }
   
   
   
   
   //--//
   

   /**
    * Generates a stream given the parameters for each event.
    * @param start
    * @param stop
    * @param durationEvent
    * @param color
    * @param textColor
    * @param title
    * @param description
    * @param icon
    * @param image
    * @param html
    * @param trackNum
    * @return
    */
   public static ArrayList<ScenicTimelineEvent> generateEventStream(String[] start        , 
         String[] stop         ,
         String   durationEvent,
         String   color        ,
         String   title        ,
         String   description){
      ArrayList<ScenicTimelineEvent> stream = new ArrayList<ScenicTimelineEvent>();

      for(int i = 0; i < start.length; i++){
         ScenicTimelineEvent e = new ScenicTimelineEvent();
         e.start         = start[i];
         e.end           = stop[i];
         e.durationEvent = "false";
         e.color         = color;
         e.textColor     = "#000000";
         e.title         = title;
         e.description   = description;
         e.icon          = "../images/green-circle.png";
         e.image         = "../images/green-circle.png";
         e.html          = description;
         e.trackNum      = trackNum;
         e.eventId       = "" + AliceOverSpecifiedMeetingLibrary.eventId++;
         stream.add(e);
      }

      return stream;
   }
}
