package edu.washington.cs.rfid.cascadia.timeline.server.data;

import java.util.ArrayList;
import java.util.HashMap;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicCompleteEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class EventResultLibrary {

   public static String[] colors = new String[]{"#ffcc00",
                                                "#3366cc",
                                                "#00ffff",
                                                "#ffccff",
                                                "#cc33ff",
                                                "#ff3333",
                                                "#cccc33"};
   public static int trackNum = 1;
   public static int eventId  = 0;

   //--//

   public static ScenicEventResultBundle getResultBundle(int taskNum, String xml){
      HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap = EventResultLibrary.buildKeyToStreamMap();
      ScenicCompleteEventResult                      result         = EventResultLibrary.getCompleteEventResult(keyToStreamMap);

      return new ScenicEventResultBundle(xml, "Thu, 24 Sep 2009 13:03:00 +0600", result, keyToStreamMap);
   }


   public static ScenicCompleteEventResult 
      getCompleteEventResult(HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap){
      
      ScenicCompleteEventResult result = null;

      ArrayList<ScenicEventResult> sceneEvents       = EventResultLibrary.getSceneResults(keyToStreamMap);
      ArrayList<ScenicEventResult> subSequenceEvents = EventResultLibrary.getSubSequenceEvents(keyToStreamMap);

      ArrayList<ScenicTimelineEvent> stream = keyToStreamMap.get("1");
      ScenicTimelineEvent            e      = stream.get(0);

      return new ScenicCompleteEventResult(e.title, 
                                           e.description, 
                                           "1", 
                                           sceneEvents, 
                                           subSequenceEvents);
   }


   public static ArrayList<ScenicEventResult>
         getSceneResults(HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap){
      
      ArrayList<ScenicEventResult> sceneEvents = new ArrayList<ScenicEventResult>();

      //---------------Scene One--------------


      ArrayList<ScenicTimelineEvent> stream;
      ArrayList<ScenicEventResult> modelData = new ArrayList<ScenicEventResult>();
      ScenicTimelineEvent       e;
      ScenicEventResult result;

      // 3) Primitive
      stream = keyToStreamMap.get(8 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     8 + "", 
                                     modelData);
      ArrayList<ScenicEventResult> primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);


      // 4) Scene
      stream = keyToStreamMap.get(5 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     5 + "", 
                                     primitiveEvents);
      sceneEvents.add(result);



      //---------------Scene Two--------------

      // 3) Primitive
      stream = keyToStreamMap.get(9 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     9 + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);


      // 4) Scene
      stream = keyToStreamMap.get(6 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     6 + "", 
                                     primitiveEvents);
      sceneEvents.add(result);




      //---------------Scene Three------------

      
      primitiveEvents = new ArrayList<ScenicEventResult>();

      //----Evan in Magda's office----


      // 3) Primitive
      stream = keyToStreamMap.get(11 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     11 + "", 
                                     modelData);
      primitiveEvents.add(result);


      //----Magda in Magda's office----

      
      // 3) Primitive
      stream = keyToStreamMap.get(12 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     12 + "", 
                                     modelData);
      primitiveEvents.add(result);


      //----James in Magda's office----

      // 3) Primitive
      stream = keyToStreamMap.get(13 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     13 + "", 
                                     modelData);
      primitiveEvents.add(result);


      //----Gaetano in Magda's office----

      
      // 3) Primitive
      stream = keyToStreamMap.get(14 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     14 + "", 
                                     modelData);
      primitiveEvents.add(result);



      //----Evan, Magda, James and Gaetano in Magda's office----


      // 1,2) Raw data and Model Data
      modelData = new ArrayList<ScenicEventResult>();

      // 3) Primitive 
      stream = keyToStreamMap.get(10 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     10 + "", 
                                     modelData);
      primitiveEvents.add(result);


      // 4) Scene
      stream = keyToStreamMap.get(7 + "");
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     7 + "", 
                                     primitiveEvents);
                                     sceneEvents.add(result);

      return sceneEvents;
   }






   public static ArrayList<ScenicEventResult> 
      getSubSequenceEvents(HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap){
      
      ArrayList<ScenicEventResult> subSequenceEvents = new ArrayList<ScenicEventResult>();
      for(int i = 2; i <= 4; i++){

         ArrayList<ScenicTimelineEvent> stream = keyToStreamMap.get(""+ i);
         ScenicTimelineEvent       e      = stream.get(0);
         ScenicEventResult         r      = new ScenicEventResult(e.title, 
                                                                  e.description, 
                                                                  "" + i, 
                                                                  null);
         subSequenceEvents.add(r);
      }
      return subSequenceEvents;
   }






   public static HashMap<String,ArrayList<ScenicTimelineEvent>> buildKeyToStreamMap(){
      HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap = new HashMap<String,ArrayList<ScenicTimelineEvent>>();

      int streamKey = 1;
      // 1
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getCompleteEventStream());

      // 2
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getFirstSubSequenceEventStream());
      // 3
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSecondSubSequenceEventStream());
      // 4
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getThirdSubSequenceEventStream());

      // 5
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneOneEventStream());
      // 6
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneTwoEventStream());
      // 7
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeEventStream());

      // 8
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneOneEvanInsideOfficeStream());
      // 9
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneTwoEvanOutsideOfficeStream());
      // 10
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeAllInsideMagdaOfficeStream());
      // 11
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeEvanInsideMagdaOfficeStream());
      // 12
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeMagdaInsideMagdaOfficeStream());
      // 13
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeJamesInsideMagdaOfficeStream());
      // 14
      keyToStreamMap.put("" + streamKey++, EventResultLibrary.getSceneThreeGaetanoInsideMagdaOfficeStream());

      //// 15
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getEvanAtStream());
      //// 16
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getMagdaAtStream());
      //// 17
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getJamesAtStream());
      //// 18
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getGaetanoAtStream());
      //
      //// 19
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getEvanTreStream());
      //// 20
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getMagdaTreStream());
      //// 21
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getJamesTreStream());
      //// 22
      //keyToStreamMap.put("" + streamKey++, EventResultLibrary.getGaetanoTreStream());

      return keyToStreamMap;
   }


   public static ArrayList<ScenicTimelineEvent> getCompleteEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:32:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:32:07 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[0], 
            "#000000", 
            "Event", 
            "Evan leaves his office and goes to a meeting with Magda, James and Gaetano.", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan leaves his office and goes to a meeting with Magda, James and Gaetano.", 
            1);
   }

   public static ArrayList<ScenicTimelineEvent> getFirstSubSequenceEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:32:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:32:07 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[1], 
            "#000000", 
            "Scenes 1, 2, 3", 
            "Scenes 1, 2, 3", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Scenes 1, 2, 3", 
            2);
   }

   public static ArrayList<ScenicTimelineEvent> getSecondSubSequenceEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:46:23 +0600", "Thu, 24 Sep 2009 14:17:01 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 13:46:48 +0600", "Thu, 24 Sep 2009 14:17:09 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[2], 
            "#000000", 
            "Scenes 1, 2", 
            "Scenes 1, 2", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Scenes 1, 2", 
            3);
   }

   public static ArrayList<ScenicTimelineEvent> getThirdSubSequenceEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:03:00 +0600", "Thu, 24 Sep 2009 14:03:06 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 13:46:47 +0600", "Thu, 24 Sep 2009 14:17:08 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[3], 
            "#000000", 
            "Scenes 1", 
            "Scenes 1", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Scenes 1", 
            4);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneOneEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:03:00 +0600", "Thu, 24 Sep 2009 14:03:06 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 13:46:47 +0600", "Thu, 24 Sep 2009 14:17:08 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[4], 
            "#000000", 
            "Scene 1", 
            "Evan is inside his office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan is inside his office", 
            5);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneTwoEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:46:23 +0600", "Thu, 24 Sep 2009 14:17:01 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:03:32 +0600", "Thu, 24 Sep 2009 15:35:29 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[5], 
            "#000000", 
            "Scene 2", 
            "Evan is outside his office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan is outside his office", 
            6);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeEventStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:32:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:20:36 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "Scene 3", 
            "Evan, Magda, James and Gaetano are in Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan, Magda, James and Gaetano are in Magda's office", 
            7);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneOneEvanInsideOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:03:00 +0600", "Thu, 24 Sep 2009 14:03:06 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 13:46:47 +0600", "Thu, 24 Sep 2009 14:17:08 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[4], 
            "#000000", 
            "Evan is inside his office", 
            "Evan is inside his office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan is inside his office", 
            8);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneTwoEvanOutsideOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:46:23 +0600", "Thu, 24 Sep 2009 14:17:01 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:03:32 +0600", "Thu, 24 Sep 2009 15:35:29 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[5], 
            "#000000", 
            "Evan is outside his office", 
            "Evan is outside his office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan is outside his office", 
            9);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeAllInsideMagdaOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:32:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:20:36 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "Evan, Magda, James and Gaetano are in Magda's office", 
            "Evan, Magda, James and Gaetano are in Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan, Magda, James and Gaetano are in Magda's office", 
            10);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeEvanInsideMagdaOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:28:15 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:28:03 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "Evan is inside Magda's office", 
            "Evan is inside Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan is inside Magda's office", 
            11);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeMagdaInsideMagdaOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:19:38 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:34:53 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "Magda is inside Magda's office", 
            "Magda is inside Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Magda is inside Magda's office", 
            12);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeJamesInsideMagdaOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:26:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:20:36 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "James is inside Magda's office", 
            "James is inside Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "James is inside Magda's office", 
            13);
   }


   public static ArrayList<ScenicTimelineEvent> getSceneThreeGaetanoInsideMagdaOfficeStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:32:02 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 15:28:04 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[6], 
            "#000000", 
            "Gaetano is inside Magda's office", 
            "Gaetano is inside Magda's office", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Gaetano is inside Magda's office", 
            14);
   }


   public static ArrayList<ScenicTimelineEvent> getEvanAtStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:00:00 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 16:00:00 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[0], 
            "#000000", 
            "Evan Model", 
            "Evan Model", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan Model", 
            15);
   }


   public static ArrayList<ScenicTimelineEvent> getMagdaAtStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:00:00 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 16:00:00 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[0], 
            "#000000", 
            "Magda Model", 
            "Magda Model", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Magda Model", 
            16);
   }


   public static ArrayList<ScenicTimelineEvent> getJamesAtStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:00:00 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 16:00:00 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[0], 
            "#000000", 
            "James Model", 
            "James Model", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "James Model", 
            17);
   }


   public static ArrayList<ScenicTimelineEvent> getGaetanoAtStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:00:00 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 16:00:00 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[0], 
            "#000000", 
            "Gaetano Model", 
            "Gaetano Model", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Gaetano Model", 
            18);
   }


   public static ArrayList<ScenicTimelineEvent> getEvanTreStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 13:46:23 +0600", "Thu, 24 Sep 2009 14:17:05 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:03:06 +0600", "Thu, 24 Sep 2009 14:28:14 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[1], 
            "#000000", 
            "Evan Tag Reads", 
            "Evan Tag Reads", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Evan Tag Reads", 
            19);
   }


   public static ArrayList<ScenicTimelineEvent> getMagdaTreStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:10:07 +0600", "Thu, 24 Sep 2009 15:34:05 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:19:30 +0600", "Thu, 24 Sep 2009 15:59:53 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[1], 
            "#000000", 
            "Magda Tag Reads", 
            "Magda Tag Reads", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Magda Tag Reads", 
            20);
   }


   public static ArrayList<ScenicTimelineEvent> getJamesTreStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:24:17 +0600", "Thu, 24 Sep 2009 15:22:45 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:26:02 +0600", "Thu, 24 Sep 2009 15:25:05 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[1], 
            "#000000", 
            "James Tag Reads", 
            "James Tag Reads", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "James Tag Reads", 
            21);
   }


   public static ArrayList<ScenicTimelineEvent> getGaetanoTreStream(){
      String[] start = new String[]{"Thu, 24 Sep 2009 14:31:36 +0600", "Thu, 24 Sep 2009 15:28:05 +0600"};
      String[] stop  = new String[]{"Thu, 24 Sep 2009 14:32:15 +0600", "Thu, 24 Sep 2009 15:34:42 +0600"};

      return EventResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            EventResultLibrary.colors[1], 
            "#000000", 
            "Gaetano Tag Reads", 
            "Gaetano Tag Reads", 
            "../images/green-circle.png",
            "../images/green-circle.png", 
            "Gaetano Tag Reads", 
            22);
   }


   /**
    * Generates a stream given the parameters for each event.
    * @param start
    * @param stop
    * @param durationEvent
    * @param color
    * @param textColor
    * @param title
    * @param description
    * @param icon
    * @param image
    * @param html
    * @param trackNum
    * @return
    */
   public static ArrayList<ScenicTimelineEvent> generateEventStream(String[] start        , 
         String[] stop         ,
         String   durationEvent,
         String   color        ,
         String   textColor    ,
         String   title        ,
         String   description  ,
         String   icon         ,
         String   image        ,
         String   html         ,
         int      trackNum){  
      ArrayList<ScenicTimelineEvent> stream = new ArrayList<ScenicTimelineEvent>();

      for(int i = 0; i < start.length; i++){
         ScenicTimelineEvent e = new ScenicTimelineEvent();
         e.start         = start[i];
         e.end           = stop[i];
         e.durationEvent = "false"; //TODO: this is a test -- durationEvent;
         e.color         = color;
         e.textColor     = textColor;
         e.title         = title;
         e.description   = description;
         e.icon          = icon;
         e.image         = image;
         e.html          = html;
         e.trackNum      = trackNum;
         e.eventId       = "" + EventResultLibrary.eventId++;
         stream.add(e);
      }

      return stream;
   }
}
