package edu.washington.cs.rfid.cascadia.timeline.server.data;

import java.util.ArrayList;
import java.util.HashMap;

import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicCompleteEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResult;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicEventResultBundle;
import edu.washington.cs.rfid.cascadia.timeline.client.event.ScenicTimelineEvent;

public class JamesAliceStudyResultLibrary {

   
   public static String[] colors = new String[]{"#ffcc00",
                                                "#3366cc",
                                                "#00ffff",
                                                "#ffccff",
                                                "#cc33ff",
                                                "#ff3333",
                                                "#cccc33"};
   public static int trackNum = 1;
   public static int eventId  = 0;

   //--//

   public static ScenicEventResultBundle getResultBundle(int taskNum, String xml){

      HashMap<String,ArrayList<ScenicTimelineEvent>> keyToStreamMap = new HashMap<String,ArrayList<ScenicTimelineEvent>>();
      ScenicCompleteEventResult                      completeResult = null;
      
      
      int                            streamKey = 0;
      ArrayList<ScenicTimelineEvent> stream    = null;
      ArrayList<ScenicEventResult>   modelData = new ArrayList<ScenicEventResult>();
      ScenicTimelineEvent            e         = null;
      ScenicEventResult              result    = null;
      
      
      // BUILD SCENES-----------------------------------------------------------------------------
      ArrayList<ScenicEventResult> sceneEvents = new ArrayList<ScenicEventResult>();
      ArrayList<ScenicEventResult> primitiveEvents = null;
      
      //----------- SCENE ONE --------------

      
      // Primitive 1
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneOneWithNotesStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Primitive 2
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneOneAliceInsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents.add(result);
      
      
      // Primitive 3
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneOneJamesOutsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents.add(result);
      
      
      // Scene
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneOneEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);
      
      

      
      //----------- SCENE TWO --------------

      // Primitive 1
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneTwoAliceWithNotesStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents = new ArrayList<ScenicEventResult>();
      primitiveEvents.add(result);
      
      
      // Primitive 2
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneTwoJamesInsideOfficeStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     modelData);
      primitiveEvents.add(result);
      
//    streamKey++;
//    stream = JamesAliceStudyResultLibrary.getSceneTwoNotesInsideOfficeStream();
//    keyToStreamMap.put("" + streamKey, stream);
//    
//    e      = stream.get(0);
//    result = new ScenicEventResult(e.title, 
//                                   e.description, 
//                                   streamKey + "", 
//                                   modelData);
//    primitiveEvents.add(result);
//
//    
//    // Primitive 3
      

      // Scene
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSceneTwoEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     primitiveEvents);
      sceneEvents.add(result);

      
      // BUILD SUBSEQUENCES-----------------------------------------------------------------------------
      
      ArrayList<ScenicEventResult> subSequenceEvents = new ArrayList<ScenicEventResult>();
      
      
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getSecondSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getFirstSubSequenceEventStream();
      keyToStreamMap.put("" + streamKey, stream);
      e      = stream.get(0);
      result = new ScenicEventResult(e.title, 
                                     e.description, 
                                     streamKey + "", 
                                     null);
      subSequenceEvents.add(result);
      
      
      
      
      // BUILD COMPLETE EVENT-----------------------------------------------------------------------------
      
      streamKey++;
      stream = JamesAliceStudyResultLibrary.getCompleteEventStream();
      keyToStreamMap.put("" + streamKey,stream);
      
      e      = stream.get(0);

      completeResult = new ScenicCompleteEventResult(e.title, 
                                           e.description, 
                                           "" + streamKey, 
                                           sceneEvents, 
                                           subSequenceEvents);
      
      
      
      return new ScenicEventResultBundle(xml, "Wed, 23 Sep 2009 10:00:30 +0000", completeResult, keyToStreamMap);
   }

 
   
   
   
   
   //------------------------------ EVENT CREATION ------------------------------------------------------------


   public static ArrayList<ScenicTimelineEvent> getCompleteEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:01:15 +0000","Thu, 24 Sep 2009 11:31:15 +0000","Fri, 25 Sep 2009 12:03:39 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:01:25 +0000","Thu, 24 Sep 2009 11:31:25 +0000","Fri, 25 Sep 2009 12:03:49 +0000"};
      
      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[0], 
            "Event", 
            "James visits Alice to study algorithms");
   }

   public static ArrayList<ScenicTimelineEvent> getFirstSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000","Wed, 23 Sep 2009 10:02:27 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000","Thu, 24 Sep 2009 11:32:27 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000","Fri, 25 Sep 2009 12:04:54 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:01:14 +0000","Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:31:14 +0000","Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:03:39 +0000","Fri, 25 Sep 2009 12:05:48 +0000"};

      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[0], 
            "Scenes 1", 
            "Scenes 1");
   }
   
   public static ArrayList<ScenicTimelineEvent> getSecondSubSequenceEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:01:15 +0000","Thu, 24 Sep 2009 11:31:15 +0000","Fri, 25 Sep 2009 12:03:39 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:01:25 +0000","Thu, 24 Sep 2009 11:31:25 +0000","Fri, 25 Sep 2009 12:03:49 +0000"};
      
      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[0], 
            "Scenes 1,2", 
            "Scenes 1,2");
   }
   
   
   //******************************SCENE ONE******************************************

   public static ArrayList<ScenicTimelineEvent> getSceneOneEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000","Wed, 23 Sep 2009 10:02:27 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000","Thu, 24 Sep 2009 11:32:27 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000","Fri, 25 Sep 2009 12:04:54 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:01:14 +0000","Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:31:14 +0000","Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:03:39 +0000","Fri, 25 Sep 2009 12:05:48 +0000"};

      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[4],
            "Scene 1", 
            "Alice is inside her office with her notes, James is outside Alice's office.");
   }

   
   // Scene 1, Primitive 1 - ALICE WITH NOTES
   public static ArrayList<ScenicTimelineEvent> getSceneOneWithNotesStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:05:48 +0000"};

      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[4],
            "Alice's is with her notes", 
            "Alice's is with her notes");
   }

   
   // Scene 1, Primitive 2 - ALICE INSIDE OFFICE
   public static ArrayList<ScenicTimelineEvent> getSceneOneAliceInsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:05:48 +0000"};

      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[4],
            "Alice is inside her office", 
            "Alice is inside her office");
   }
   
   
   // Scene 1, Primitive 3 - JAMES OUTSIDE OFFICE
   public static ArrayList<ScenicTimelineEvent> getSceneOneJamesOutsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000","Wed, 23 Sep 2009 10:02:27 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000","Thu, 24 Sep 2009 11:32:27 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000","Fri, 25 Sep 2009 12:04:54 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:01:14 +0000","Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:31:14 +0000","Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:03:39 +0000","Fri, 25 Sep 2009 12:05:48 +0000"};

      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[4],
            "James is outside Alice's office", 
            "James is outside Alice's office");
   }
   
   
   
   
   //******************************SCENE TWO******************************************

   public static ArrayList<ScenicTimelineEvent> getSceneTwoEventStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:01:15 +0000","Thu, 24 Sep 2009 11:31:15 +0000","Fri, 25 Sep 2009 12:03:39 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:02:27 +0000","Thu, 24 Sep 2009 11:32:27 +0000","Fri, 25 Sep 2009 12:04:54 +0000"};
      
      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[5],
            "Scene 2", 
            "Alice is with her notes inside her office. James is inside Alice's office.");
   }

   
   // Scene 2, Primitive 1 - ALICE WITH NOTES
   public static ArrayList<ScenicTimelineEvent> getSceneTwoAliceWithNotesStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000",
                                    "Thu, 24 Sep 2009 11:30:05 +0000",
                                    "Fri, 25 Sep 2009 12:00:05 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:05:48 +0000",
                                    "Thu, 24 Sep 2009 11:35:48 +0000",
                                    "Fri, 25 Sep 2009 12:05:48 +0000"};
      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[5], 
            "Alice is with her notes", 
            "Alice is with her notes");
   }
   
   // Scene 2, Primitive 2 - JAMES AND ALICE INSIDE OFFICE
   public static ArrayList<ScenicTimelineEvent> getSceneTwoJamesInsideOfficeStream(){
      String[] start = new String[]{"Wed, 23 Sep 2009 10:01:15 +0000","Thu, 24 Sep 2009 11:31:15 +0000","Fri, 25 Sep 2009 12:03:39 +0000"};
      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:02:27 +0000","Thu, 24 Sep 2009 11:32:27 +0000","Fri, 25 Sep 2009 12:04:54 +0000"};
      
      return JamesAliceStudyResultLibrary.generateEventStream(start, 
            stop, 
            "true", 
            JamesAliceStudyResultLibrary.colors[5], 
            "Alice and James are inside Alice's office", 
            "Alice and James are inside Alice's office");
   }
   
   
   
   
//   public static ArrayList<ScenicTimelineEvent> getSceneTwoNotesInsideOfficeStream(){
//      String[] start = new String[]{"Wed, 23 Sep 2009 10:00:05 +0000",
//                                    "Thu, 24 Sep 2009 11:30:05 +0000",
//                                    "Fri, 25 Sep 2009 12:00:05 +0000"};
//      String[] stop  = new String[]{"Wed, 23 Sep 2009 10:05:30 +0000",
//                                    "Thu, 24 Sep 2009 11:35:30 +0000",
//                                    "Fri, 25 Sep 2009 12:05:30 +0000"};
//      return JamesAliceStudyResultLibrary.generateEventStream(start, 
//            stop, 
//            "true", 
//            JamesAliceStudyResultLibrary.colors[5], 
//            "Alice's notes are inside her office", 
//            "Alice's notes are inside her office");
//   }
   
   
   //--//
   

   /**
    * Generates a stream given the parameters for each event.
    * @param start
    * @param stop
    * @param durationEvent
    * @param color
    * @param textColor
    * @param title
    * @param description
    * @param icon
    * @param image
    * @param html
    * @param trackNum
    * @return
    */
   public static ArrayList<ScenicTimelineEvent> generateEventStream(String[] start        , 
         String[] stop         ,
         String   durationEvent,
         String   color        ,
         String   title        ,
         String   description){
      ArrayList<ScenicTimelineEvent> stream = new ArrayList<ScenicTimelineEvent>();

      for(int i = 0; i < start.length; i++){
         ScenicTimelineEvent e = new ScenicTimelineEvent();
         e.start         = start[i];
         e.end           = stop[i];
         e.durationEvent = "false";
         e.color         = color;
         e.textColor     = "#000000";
         e.title         = title;
         e.description   = description;
         e.icon          = "../images/green-circle.png";
         e.image         = "../images/green-circle.png";
         e.html          = description;
         e.trackNum      = trackNum;
         e.eventId       = "" + JamesAliceStudyResultLibrary.eventId++;
         stream.add(e);
      }

      return stream;
   }
}
