package edu.washington.cs.rfid.data;

import java.io.Serializable;

/**
 * A memory-resident representation of an edge.
 * 
 * @author Evan
 */
public class Edge implements Serializable {

	private static final long serialVersionUID = 3923467351375L;
	
	//--//
	
	public long firstNodeID;
	public long secondNodeID;
	
	//--//
	
	/**
	 * Creates a new <code>Edge</code> with the specified parameters.
	 * 
	 * @param firstNodeID
	 * @param secondNodeID
	 */
	public Edge(long firstNodeID, long secondNodeID){
		this.firstNodeID  = firstNodeID;
		this.secondNodeID = secondNodeID;
	}
	
	
	/**
	 * Returns a <code>String</code> representing this <code>Edge</code>.
	 * 
	 * @return A <code>String</code> representing this <code>Edge</code>
	 */
	public String toString(){
		return "( " + this.firstNodeID + " , " + this.secondNodeID + " )";
	}
}
