package edu.washington.cs.rfid.data;

import java.io.Serializable;
import java.util.Date;

/**
 * Indicates that a particular tagged object was at a particular
 * location at the specified time.
 * 
 * @author Evan
 */
public class EntityAtLocation implements Serializable {
	
	private static final long serialVersionUID = 87623192644521L;
	
	//--//
	
	public long   tid;
	public String name;
	public String imgUrl;
	public String owner;
	public int    aid;
	public String loc;
	public double lat;
	public double lng;
	public long   nid;
	public Date   startTime;
	public Date   endTime;

	//--//
	
	public EntityAtLocation(long   tid      ,
							String name     ,
							String imgUrl   ,
							String owner    ,
							int    aid      ,
							String loc      ,
							double lat      ,
							double lng      ,
							long   nid      ,
							Date   startTime,
							Date   endTime){
		this.tid       = tid;
		this.name      = name;
		this.imgUrl    = imgUrl;
		this.owner     = owner;
		this.aid       = aid;
		this.loc       = loc;
		this.lat       = lat;
		this.lng       = lng;
		this.nid       = nid;
		this.startTime = startTime;
		this.endTime   = endTime;
	}

	
	/**
	 * Returns a <code>String</code> representing this <code>ObjectAtLocation</code>.
	 * 
	 * @return A <code>String</code> representing this <code>ObjectAtLocation</code>
	 */
	public String toString(){
		return "( " + this.tid + " , " + this.name + " , " + this.imgUrl + " , " + this.owner + 
		       " , " + this.aid + " , " + this.loc + " , " + this.lat +
		       " , " + this.lng + " , " + this.nid + " , " + this.startTime + 
		       " , " + this.endTime + " )";
	}	
}
