package edu.washington.cs.rfid.data;

import java.io.Serializable;


/**
 * The memory resident representation of an entity type.
 * 
 * @author Evan
 */
public class EntityType implements Serializable {

	private static final long serialVersionUID = 667396643L;
	
	//--//
	
	private static final String DEFAULT_IMG_URL = "http://rfid.cs.washington.edu/dbicons/unknown.png";

	//--//
	
	public int    typeId;		// The type ID
	public String name;			// A description of the object type
	public String imgUrl;		// URL for an image of the object type
	
	//--//
	
	/**
	 * Creates a new <code>ObjectTypeMetadata</code> with default parameters.
	 */
	public EntityType(){
		this.typeId = -1;
		this.name   = null;
		this.imgUrl = null;
	}
	
	
	/**
	 * Creates an <code>ObjectTypeMetadata</code> with the specified parameters. 
	 * 
	 * @param typeId The ID of the object type
	 * @param desc A description of the object type
	 * @param imgUrl URL for an image of the object type
	 */
	public EntityType(int typeId, String desc, String imgUrl){
		this.typeId = typeId;
		this.name   = desc;
		this.imgUrl = imgUrl;
	}
}