package edu.washington.cs.rfid.data;

import java.io.Serializable;

/**
 * The memory-resident representation of a node.
 * 
 * @author Evan
 */
public class Node implements Serializable {
	
	private static final long serialVersionUID = 86912716649818L;

	//--//
	
	public long   nid;
	public double lat;
	public double lon;
	public double alt;
	public int    floor;
	public String sid;
	
	//--//
	
	/**
	 * Creates a new <code>Node</code> with the specified parameters.
	 * 
	 * @param nid
	 * @param lat
	 * @param lon
	 * @param alt
	 * @param floor
	 * @param sid
	 */
	public Node(long nid, double lat, double lon, double alt, int floor, String sid){
		this.nid   = nid;
		this.lat   = lat;
		this.lon   = lon;
		this.alt   = alt;
		this.floor = floor;
		this.sid   = sid;
	}
	
	
	/**
	 * Returns a <code>String</code> representing this <code>Node</code>.
	 * 
	 * @return A <code>String</code> representing this <code>Node</code>
	 */
	public String toString(){
		return "( " + this.nid + " , " + this.lat + " , " + this.lon + 
		       " , " + this.alt + " , " + this.floor + " , " + this.sid + " )";
	}
}
