package edu.washington.cs.rfid.data;

import java.io.Serializable;


/**
 * The memory-resident representation of a reader.
 * 
 * @author Evan
 */
public class Rdr implements Serializable {

	private static final long serialVersionUID = 725895623L;

	//--//
	
	public int    rid;			// Reader ID
	public String sid;			// Symbolic ID (ex: "North side of CSE 405")
	public int    floor;		// Floor number
	public double lat;			// Latitude 			
	public double lon;			// Longitude
	public double alt;			// Altitude
	public int    assetNum;		// The asset num of the reader
	public String hostname;		// The hostname of the reader
	public int    port;			// The port of the reader
	

	//--//
	
	/**
	 * Creates a new <code>Rdr</code> with the specified parameters.
	 * 
	 * @param rdID The reader ID
	 * @param sid The symbolic ID (ex: "North side of CSE 405")
	 * @param floor The floor number
	 * @param lat The latitude of the reader
	 * @param lon The longitude
	 * @param hostname The hostname of the reader
	 * @param port The port of the reader
	 */
	public Rdr(int    rid     , 
		       String sid     , 
		       int    floor   ,
		       double lat     , 
		       double lon     ,
		       double alt     ,
		       int    assetNum,
		       String hostname, 
		       int    port){
		this.rid 	  = rid;
		this.sid 	  = sid;
		this.floor 	  = floor;
		this.lat 	  = lat;
		this.lon      = lon;
		this.alt      = alt;
		this.assetNum = assetNum;
		this.hostname = hostname;
		this.port     = port;
	}
}