package edu.washington.cs.rfid.data;

import java.io.Serializable;


/**
 * The memory-resident representation of a tag.
 * 
 * @author Evan
 */
public class Tag implements Serializable {

	private static final long serialVersionUID = 2389472394L;

	//--//
	
	public long tid;		// Hashed tag ID
	public int  eid;		// ID of the tagged entity
	public long startTime;	// Time when the tag-to-entity association was created
	public long endTime;	// Time when this tag-to-entity association ended
	
	//--//
	
	/**
	 * Creates a <code>Tag</code> entity with the specified parameters.
	 * 
	 * @param tid The ID of the tag
	 * @param eid The ID of the tagged entity
	 * @param startTime The time when this tag-to-entity association was created
	 * @param endTime The time when this tag-to-entity association ended
	 */
	public Tag(long tid, int eid, long startTime, long endTime){
		this.tid       = tid;
		this.eid       = eid;
		this.startTime = startTime;
		this.endTime   = endTime;
	}
}