package edu.washington.cs.rfid.map.client.data;

import com.google.gwt.user.client.rpc.IsSerializable;

public class TagReading implements IsSerializable {

   public String floor;
   public LatLon loc;
   
   //--//
   
   /**
    * Creates a new tag reading.
    */
   public TagReading(){
      this.floor = null;
      this.loc   = null;
   }
   
   /**
    * Creates a new tag reading with the specified parameters.
    * @param floor
    * @param loc
    */
   public TagReading(String floor, LatLon loc){
      this.floor = floor;
      this.loc   = loc;
   }
   
   
   /**
    * Checks for equality between this tag reading to another. 
    * @param r
    * @return
    */
   public boolean equals(TagReading r){
      return this.floor.equals(r)      && 
             this.loc.lat == r.loc.lat &&
             this.loc.lon == r.loc.lon;
   }
}