package edu.washington.cs.rfid.map.client.ui;

import com.google.gwt.maps.client.CopyrightCollection;
import com.google.gwt.maps.client.TileLayer;
import com.google.gwt.maps.client.geom.Point;

public class MercatorTileLayer extends TileLayer {

	private String baseURL;
	private int    floorNum;
	
	//--//
	
	public MercatorTileLayer(CopyrightCollection copyrights   , 
	                         int                 minResolution, 
	                         int                 maxResolution, 
	                         String              baseURL      , 
	                         String              floor) {
		super(copyrights, minResolution, maxResolution);
		this.baseURL  = baseURL;
		
		for(int i = 0; i < MercatorMapWidget.DEFAULT_FLOORS.length; i++){
		   if(floor.equals(MercatorMapWidget.DEFAULT_FLOORS[i])){
		      this.floorNum = i;
		      break;
		   }
		}
	}

	public double getOpacity() {
		return 1.0;
	}

	public String getTileURL(Point tile, int zoomLevel) {		
		return baseURL + "floor" + this.floorNum + 
			    "/"     + tileToQuadKey(tile.getX(), tile.getY(),zoomLevel) + ".png";
	}
	
	/**
	 * The MapCruncher tile file names have one digit for each zoom level and 
	 * use a quadtree format with the digits 0,1,2,3 
	 * ( see http://en.wikipedia.org/wiki/Quadtree ).
	 *  It turns out to be a simple matter to convert the x,y and zoom 
	 *  of a call on the GMap getTileUrl function to a filename in this 
	 *  quadtree format. Here is the Java Script code that does it.
	 *  
	 * @param x
	 * @param y
	 * @param zoom
	 * @return
	 */
	private String tileToQuadKey(int x, int y, int zoom) {
		String quad = "";
		for(int i=zoom; i > 0; i--) {
			int mask = 1 << (i - 1);
			int cell = 0;
			if((x & mask) != 0) {
				cell++;
			}
			if(((y & mask) != 0)) {
				cell+=2;
			}
			quad+= "" + cell;
		}
		return quad; 
	}

	public boolean isPng() {
		return true;
	}
}
